Offline = {
    db             : null,
    persistentPath : "/persistent/",

    init_data : function( callbackReturn ){

        if( !window.indexedDB ){
            alert( "Seu navegador não suporta Offline" );
        }

        var request = indexedDB.open( `${AppConfig.wwwroot_web}-v1`, 1 );

        request.onupgradeneeded = function( event ){
            Offline.db = event.target.result;

            Offline.db.createObjectStore( 'offline', {
                autoIncrement : true
            } );

            Offline.db.createObjectStore( 'makeview', {
                autoIncrement : true
            } );

            Offline.db.createObjectStore( 'scorm', {
                autoIncrement : true
            } );
        };
        request.onerror         = function( event ){
            // console.error ( `Database error: ${event.target.errorCode}` );
        };
        request.onsuccess       = function( event ){
            // console.log ( `Database success: ${event.target.result}` );
            Offline.db = event.target.result;

            callbackReturn && callbackReturn();
            callbackReturn = null;

            ModMakeView.init_cron();
        };
    },

    init_storage : function(){
        if( typeof requestFileSystem == 'undefined' ){
            return;
        }

        window.requestFileSystem( window.PERSISTENT, 5 * 1024 * 1024, function( fs ){
            // console.log ( 'file temp system open: ', fs );
            Offline.persistentPath = fs.root.nativeURL;
            if( Offline.persistentPath == undefined ){
                Offline.persistentPath = "";
            }
        }, function( e ){
            // console.error ( e );
        } );
        //Offline.persistentPath = cordova.file.externalDataDirectory;
    },

    insertOffline : function( key, value ){

        // create a new transaction
        var txn = Offline.db.transaction( 'offline', 'readwrite' );

        // get the Offline object store
        var store = txn.objectStore( 'offline' );
        var query = store.put( value, key );

        // handle success case
        query.onsuccess = function( event ){
            // console.log ( "insertOffline: " + key );
        };

        // handle the error case
        query.onerror = function( event ){
            // console.log ( "insertOffline: " + key );
            // console.log ( event.target.errorCode );
        };
    },

    getOfflineById : function( key, successCallback, errorCallback ){

        var txn   = Offline.db.transaction( 'offline', 'readonly' );
        var store = txn.objectStore( 'offline' );

        var query = store.get( key );

        query.onsuccess = function( event ){
            if( !event.target.result ){
                // console.log ( `The data with ${key} not found` );

                errorCallback && errorCallback();

            }else{
                //console.table ( event.target.result );
                successCallback( event.target.result );
            }
        };

        query.onerror = function( event ){
            errorCallback && errorCallback( event );
        };
    },

    deleteOffline : function( key ){
        // create a new transaction
        var txn = Offline.db.transaction( 'offline', 'readwrite' );

        // get the Offline object store
        var store = txn.objectStore( 'offline' );
        //
        var query = store.delete( key );

        // handle the success case
        query.onsuccess = function( event ){
            // console.log ( event );
        };

        // handle the error case
        query.onerror = function( event ){
            // console.log ( event.target.errorCode );
        };
    },
};
