UserClass = {

    fullname        : "Usuario de testes do APP",
    userid          : 0,
    userissiteadmin : false,
    username        : "usuario-app",

    package_name    : '',
    package_uid     : '',
    package_version : '',

    core_webservice_get_site_info : function(){
        var data = {
            wsfunction : "core_webservice_get_site_info",
        };
        DataLoad.loadWebserviceOfflineData(
            data,
            UserClass.core_webservice_get_site_info_success,
            UserClass.core_webservice_get_site_info_error,
            true );
    },

    core_webservice_get_site_info_success : function( data ){
        if( data.errorcode == "invalidtoken" ){
            Login.show();
            $( "#page-home" ).hide();

        }else if( data.error ){
            Login.show();
            $( "#page-home" ).hide();

        }else{
            Login.hide();
            $( "#page-home" ).show();

            var iterate = $.each( data, function( key, val ){
                UserClass[ key ] = val;
            } );

            document.getElementById( 'page-home' ).replacePage( "page/home/index/index.html", {
                callback : function(){
                    setTimeout( function(){
                        CourseList.loadCursos();
                        UserClass.oneSignal_initialize();
                        ImageCache.loadAllIconModules();
                        ImageCache.loadCoursePicture();
                        PageHome.showHome();
                    }, 300 );
                }
            } );

            if( UserClass.release.indexOf( "3" ) === 0 ){
                $( "body" ).addClass( "moodle3" )
            }else if( UserClass.release.indexOf( "4" ) === 0 ){
                $( "body" ).addClass( "moodle4" )
            }
        }
    },

    core_webservice_get_site_info_error : function( data ){
        console.trace( data );
    },

    oneSignal_initialize : function(){
        if( typeof window.plugins == 'undefined' ) return;
        if( typeof window.plugins.OneSignal == 'undefined' ) return;

        /*-*/
        window.plugins.OneSignal.Debug.setLogLevel( 6 );
        //window.plugins.OneSignal.Debug.setAlertLevel( 6 );
        /**/

        window.plugins.OneSignal.initialize( AppConfig.OneSignalAppId );

        window.plugins.OneSignal.login( `${UserClass.package_uid}:${UserClass.userid}` );
        window.plugins.OneSignal.User.setLanguage( "pt" );
        window.plugins.OneSignal.User.addAlias( "Nome Aluno", `${UserClass.fullname}` );
        window.plugins.OneSignal.User.addAlias( "Link Perfil", `${AppConfig.wwwroot}/user/profile.php?id=${UserClass.userid}` );

        window.plugins.OneSignal.InAppMessages.addEventListener( "click", function( event ){
            console.log( event );
        } );

        window.plugins.OneSignal.Notifications.addEventListener( "click", function( event ){
            // "notification" : {
            //     "body"           : "Este é o corpo da mensagem",
            //     "title"          : "teste",
            //     "additionalData" : {
            //         "type"      : "url | mod",
            //         "url"       : "http://////",
            //         "course_id" : 123,
            //         "mod_id"    : 123
            //     },
            // },

            console.log( event );
            if( event.notification && event.notification.additionalData && event.notification.additionalData.type ){
                if( event.notification.additionalData.type == "url" ){
                    var urlOpen = event.notification.additionalData.url;
                    if( typeof urlOpen[ 10 ] != 'undefined' ){
                        OpenUrl.open_show_location( event.data.href );
                        return;
                    }
                }
                if( event.notification.additionalData.type == "mod" ){
                    var course_id = event.notification.additionalData.course_id;
                    var mod_id    = event.notification.additionalData.mod_id;

                    if( course_id && mod_id ){
                        $( "#page-home > ons-page.page" )
                            .show()
                            .each( function( id, element ){
                                var $element = $( element );
                                if( $element.attr( "id" ) != undefined ){
                                    $element.remove();
                                }
                            } );
                        $( `#courseid-${course_id}` ).click();

                        function pageopenPushpageComplete_handler(){
                            document.removeEventListener( "pageopen_pushpage_complete", pageopenPushpageComplete_handler );

                            setTimeout( function(){
                                if( document.getElementById( `module-${mod_id}` ) ){
                                    $( `#module-${mod_id}` ).click();
                                }else{
                                    var module = ModuleOpen.allModules[ mod_id ];
                                    ModuleOpen.module_click( module );
                                }
                            }, 500 );
                        }

                        document.addEventListener( "pageopen_pushpage_complete", pageopenPushpageComplete_handler );
                    }
                }
            }
        } );
        window.plugins.OneSignal.Notifications.addEventListener( "foregroundWillDisplay", function( event ){
            console.log( event );
        } );
        window.plugins.OneSignal.Notifications.addEventListener( "permissionChange", function( event ){
            console.log( event );
        } );

        window.plugins.OneSignal.Notifications.requestPermission( true ).then( function( accepted ){
            console.log( "User accepted notifications: " + accepted );
        } );


        var intervalId = setInterval( function(){
            if( window.plugins.OneSignal.User.pushSubscription._token ){
                UserClass._sendTokenMoodle();
                clearInterval( intervalId );
            }
        }, 1000 );
    },

    _sendTokenMoodle : function(){
        if( !UserClass.userid ){
            return;
        }

        var data = {
            wsfunction : "message_koperemobile_tokens_save_token",

            registration_id : window.plugins.OneSignal.User.pushSubscription._token,
            app_id          : window.plugins.OneSignal._appID,
            user_id         : UserClass.userid,

            platform_name         : device.platform + " " + device.version,
            platform_version      : navigator.appVersion,
            platform_language     : navigator.language,
            platform_manufacturer : device.manufacturer + " " + device.model,

            package_name    : UserClass.package_name,
            package_uid     : UserClass.package_uid,
            package_version : UserClass.package_version,
        };
        console.log( data );
        DataLoad.loadWebserviceOfflineData( data, null, null, false );
    }
};
