DataLoad = {

    loadWebserviceOfflineData : function( postData, successCallback, errorCallback, showError ){
        postData.moodlewsrestformat = "json";

        var url = `${AppConfig.wwwroot}/webservice/rest/server.php?wsfunction=${postData.wsfunction}`;

        DataLoad.loadOfflineData( url, postData, successCallback, errorCallback, showError, 4000 );
    },

    loadOfflineData : function( url, postData, successCallback, errorCallback, showError, timeout ){

        var alreadyReturned = false;
        var key             = JSON.stringify( postData ).replace( /[^\w.]/g, "" );

        if( postData.offline_key ){
            key = `${postData.offline_key}-_-${key}`;
            delete postData.offline_key;
        }

        if( typeof postData === "object" ){
            postData.wstoken = Login.token;
        }

        setTimeout( function(){
            if( alreadyReturned ) return;

            Offline.getOfflineById( key,
                function( data ){
                    if( data ){
                        // console.log( [ url, alreadyReturned ] );
                        !alreadyReturned && successCallback && successCallback( data );
                        alreadyReturned = true;
                        successCallback = errorCallback = null;
                    }
                }, null );
        }, timeout );

        DataLoad.load( url, postData,
            function( data ){

                Offline.insertOffline( key, data );

                !alreadyReturned && successCallback && successCallback( data );
                alreadyReturned = true;

            },
            function(){
                Offline.getOfflineById( key,
                    function( data ){
                        if( data ){
                            !alreadyReturned && successCallback && successCallback( data );
                            alreadyReturned = true;
                        }else{
                            // console.trace( 'Dados carregados offline estão inválidos!' );
                            ons.notification.toast( 'Dados carregados offline estão inválidos!', {
                                buttonLabel : 'OK',
                                timeout     : 1500
                            } );
                            Offline.deleteOffline( key );
                        }
                    },
                    function( data ){
                        //console.log( data );
                        //console.trace( [ url, postData, 'Erro ao carregar os dados e não há dados offline!' ] );
                        ons.notification.toast( 'Erro ao carregar os dados e não há dados offline!', {
                            buttonLabel : 'OK',
                            timeout     : 1500
                        } );

                        errorCallback && errorCallback();
                    } );

            },
            false );
    },

    load : function( url, postData, successCallback, errorCallback, showError ){

        $.ajax( {
            type     : "POST",
            url      : url,
            dataType : "json",
            timeout  : 30000,
            data     : postData,
            success  : function( data ){

                if( showError ){
                    if( data.errorcode && data.errorcode == "invalidtoken" ){
                        // console.trace( data.message );
                        ons.notification.toast( data.message, {
                            buttonLabel : 'OK',
                            timeout     : 3000
                        } );

                        Login.show();
                        $( "#page-home" ).hide();
                    }else if( data.exception ){

                        // console.trace( [ url, data ] );
                        ons.notification.toast( data.message, {
                            buttonLabel : 'OK',
                            timeout     : 2000
                        } );
                    }else if( data.errorcode ){

                        var message = data.message || data.error || "Erro ao carregar dados";

                        // console.trace( message );
                        ons.notification.toast( message, {
                            buttonLabel : 'OK',
                            timeout     : 3000
                        } );

                    }else if( data.error ){
                        // console.trace( data.error );
                        ons.notification.toast( data.error, {
                            buttonLabel : 'OK',
                            timeout     : 2000
                        } );
                    }
                }

                successCallback && successCallback( data );
            },
            error    : function( error ){
                // console.log ( error );

                errorCallback && errorCallback();

                if( showError ){
                    if( error.status === 0 ){
                        // console.trace( 'Você não possui conexão com a internet!' );
                        ons.notification.toast( 'Você não possui conexão com a internet!', {
                            buttonLabel : 'OK',
                            timeout     : 2000
                        } );
                    }else if( error.status === 403 ){
                        // console.trace( 'Servidor retornou que você não possui autorização para esta api!' );
                        ons.notification.toast( 'Servidor retornou que você não possui autorização para esta api!', {
                            buttonLabel : 'OK',
                            timeout     : 2000
                        } );
                    }else{
                        // console.trace( 'Erro ao processar a solicitação!' );
                        ons.notification.toast( 'Erro ao processar a solicitação!', {
                            buttonLabel : 'OK',
                            timeout     : 2000
                        } );
                    }
                }
            }
        } );
    }
};
