FileCache = {

    cacheTransfer : {},

    saveAndGet : function( url, data, onSuccessCallback, errorCallback, progressEvent, naoFazerDownload ){
        var fileCacheName = StringUtil.hashCode( url.split( /[^0-9a-zA-Z]/ ).join( "" ) );
        var extension     = /\.(pdf|mp3|mp4|zip|jpg|png|jpeg|svg|html|htm)/.exec( url );
        if( extension && extension[ 1 ] ){
            fileCacheName = `${fileCacheName}.${extension[ 1 ]}`;
        }

        var fileCdv = `${Offline.persistentPath}${fileCacheName}`;
        if( data.offline_key ){
            fileCdv = `${Offline.persistentPath}${data.offline_key}-_-${fileCacheName}`;
        }

        // para poder testar no navegador
        if( typeof resolveLocalFileSystemURL == 'undefined' ){
            onSuccessCallback && onSuccessCallback( url );
            return;
        }

        try{
            resolveLocalFileSystemURL( fileCdv,
                function( fileOk ){
                    // console.log ( "resolveLocalFileSystemURL: " + fileOk.toURL () );

                    if( onSuccessCallback ){
                        var nativeURL = fileOk.toURL();
                        if( data.WebView !== false && typeof window.Ionic == "object" && typeof window.Ionic.WebView == "object" ){
                            nativeURL = window.Ionic.WebView.convertFileSrc( fileOk.nativeURL );
                        }
                        onSuccessCallback( nativeURL );
                    }
                },
                function( evt ){

                    if( naoFazerDownload ){
                        onSuccessCallback && onSuccessCallback( url );
                        return;
                    }

                    if( FileCache.cacheTransfer[ url ] ){
                        // onSuccessCallback( url );
                        return;
                    }

                    FileCache.cacheTransfer[ url ] = new FileTransfer();
                    FileCache.cacheTransfer[ url ].download(
                        url,
                        fileCdv,
                        function( entry ){
                            // console.log ( "cacheTransfer.download: " + entry.nativeURL );
                            var nativeURL = entry.nativeURL;
                            if( data.WebView !== false && typeof window.Ionic == "object" && typeof window.Ionic.WebView == "object" ){
                                nativeURL = window.Ionic.WebView.convertFileSrc( entry.nativeURL );
                            }

                            onSuccessCallback && onSuccessCallback( nativeURL );

                            FileCache.cacheTransfer[ url ] = null;
                        },
                        function( error ){
                            // console.log ( [ "cacheTransfer.error", error ] );
                            errorCallback && errorCallback( error );

                            FileCache.cacheTransfer[ url ] = null;
                        },
                        false, { headers : {} }
                    );
                    if( progressEvent ){
                        FileCache.cacheTransfer[ url ].onprogress = function( event ){
                            if( event.lengthComputable ){
                                progressEvent( event, data )
                            }
                        };
                    }
                }
            );
        }catch( error ){
            errorCallback && errorCallback( error );
        }
    },

    deleteByCourse : function( course_id ){

        FileCache.listPath( Offline.persistentPath )
            .then( function( files ){

                for( i = 0; i < files.length; i++ ){
                    var row = files[ i ];

                    if( row.nativeURL.indexOf( `${course_id}-_-` ) ){
                        if( row.isDirectory ){
                            console.log( `Excluir pasta: ${row.nativeURL}` );
                            row.removeRecursively();
                        }else{
                            console.log( `Excluir arquivo: ${row.nativeURL}` );
                            row.remove();
                        }
                    }
                }

            }, function( error ){

            } );

    },

    listPath : function( myPath ){

        return new Promise( function( resolve, reject ){
            resolveLocalFileSystemURL( myPath, function( dirEntry ){
                dirEntry.createReader().readEntries( onSuccessCallback, onFailCallback );
            } );

            function onSuccessCallback( files ){
                resolve( files );
            }

            function onFailCallback( error ){
                reject( error );
            }
        } );
    },

    listPathRecursive : function( myPath ){

        var todosArquivos = [];
        resolveLocalFileSystemURL( myPath, function( dirEntry ){
            dirEntry.createReader().readEntries( onSuccessCallback, onFailCallback );
        } );

        function onSuccessCallback( files ){
            for( i = 0; i < files.length; i++ ){
                var row = files[ i ];

                todosArquivos.push( row );

                //row.remove ();
                if( row.isDirectory ){
                    // console.log ( 'Pasta:   ' + row.nativeURL );
                    FileCache.listPathRecursive( row.nativeURL );
                }else{
                    // console.log ( 'Arquivo: ' + row.nativeURL );
                }
            }
        }

        function onFailCallback( e ){

        }
    },

    deleteAll : function(){
        FileCache.listPath( Offline.persistentPath )
            .then( function( files ){

                for( i = 0; i < files.length; i++ ){
                    var row = files[ i ];
                    if( row.isDirectory ){
                        console.log( `Excluir pasta: ${row.nativeURL}` );
                        row.removeRecursively();
                    }else{
                        console.log( `Excluir arquivo: ${row.nativeURL}` );
                        row.remove();
                    }
                }

            }, function( error ){

            } );
    },
};


