HtmlUtil = {

    validate : function( $html ){
        if( $html ){
            HtmlUtil.href_to_external( $html );
            HtmlUtil.img_to_cache( $html );
            HtmlUtil.youtube_embed_nocookie( $html );

            $html.find( "div:empty" ).remove();
            $html.find( "p:empty" ).remove();

        }else{
            console.error( $html );
        }
    },

    href_to_external : function( $html ){
        var links = $html.find( "a:not(.href-to-external)" );
        if( !links.length ) return;

        links.each( function( id, element ){
            var $element = $( element );
            $element.addClass( "href-to-external" );
            if( !$element.attr( "data-href" ) ){
                $element.attr( "data-href", $element.attr( "href" ) );
            }
            $element.attr( "href", "#" );
            $element.click( function(){
                event.stopImmediatePropagation();
                event.stopPropagation();

                var link = $element.attr( "data-href" );
                if( link.indexOf( AppConfig.wwwroot_web ) === 0 ){
                    OpenUrl.open_external_logged( link );
                }else{
                    OpenUrl.open_show_location( link );
                }
            } );
        } );
    },

    img_to_cache : function( $html ){
        var imgs = $html.find( "img:not(.src-to-datasrc)" );
        if( !imgs.length ) return;

        imgs.each( function( id, element ){
            var $element = $( element );
            $element.addClass( "src-to-datasrc" );

            if( !$element.attr( "data-src" ) ){

                var src = $element.attr( "src" );
                if( src.indexOf( AppConfig.wwwroot_web ) === -1 ){
                    return;
                }
                src = UrlUtil.addToken( src, 600 );
                $element.attr( "src", src );
                $element.attr( "data-src", src );
            }

            var classTemporary = StringUtil.randonKey();
            $element.addClass( classTemporary );

            ImageCache.saveAndAplyByTag( `.${classTemporary}` )
        } );
    },

    youtube_embed_nocookie : function( $html ){
        var iframes = $html.find( "iframe:not(.youtube-embed)" );
        if( !iframes.length ) return;

        iframes.each( function( id, element ){
            var $element = $( element );
            $element.addClass( "youtube-embed" );

            if( src = $element.attr( "src" ) ){
                src = src.replace( "www.youtube.com", "www.youtube-nocookie.com" );
                $element.attr( "src", src );
            }else if( datasrc = $element.attr( "data-src" ) ){
                datasrc = datasrc.replace( "www.youtube.com", "www.youtube-nocookie.com" );
                $element.attr( "src", datasrc );
            }
        } );
    }
};