ImageCache = {

    allModules : {},

    loadAllIconModules         : function(){
        DataLoad.loadWebserviceOfflineData( { wsfunction : "local_kopere_mobile_mod_icon" },
            ImageCache.loadAllIconModules_success, null, true );
    },
    loadAllIconModules_success : function( data ){
        $.each( data, function( id, module ){

            var element    = {
                attr       : function( name, value ){
                    if( ImageCache.allModules[ module.name ] ){
                        ImageCache.allModules[ module.name ].cache_src = value;
                        return element;
                    }
                    return null;
                },
                removeAttr : function( name ){
                    return element;
                },
            };
            element.module = module;

            if( module.icon_ext ){
                ImageCache.saveAndAply( module.icon_url, element, null, module.icon_ext );
            }
            if( module.monologo_ext ){
                ImageCache.saveAndAply( module.monologo_url, element, null, module.monologo_ext );
            }

            ImageCache.allModules[ module.name ] = module;
        } );
    },

    loadCoursePicture : function(){
        PublicConfig.customfieldpicture = JSON.parse( PublicConfig.customfieldpicture );
        $.each( PublicConfig.customfieldpicture, function( id, picture ){
            var element     = {
                attr       : function( name, value ){
                    if( PublicConfig.customfieldpicture[ id ] ){
                        PublicConfig.customfieldpicture[ id ].cache_src = value;
                        return element;
                    }
                    return null;
                },
                removeAttr : function( name ){
                    return element;
                },
            };
            element.picture = picture;

            ImageCache.saveAndAply( picture.src, element, null, picture.extension );

            PublicConfig.customfieldpicture[ id ] = picture;
        } );
    },

    saveAndAplyByTag : function( imgTag, errorHandler404 ){
        if( cordova.platformId === 'ios' || cordova.platformId === 'android' ){
            $( `${imgTag}[data-src]` ).each( function( id, item ){

                var $element = $( item );
                if( $element.hasClass( "image-cache" ) ){
                    //console.log("hasClass \"image-cache\"");
                    return;
                }
                $element.addClass( "image-cache" );

                $element.on( "error", function( event ){
                    $element.attr( 'src', $element.attr( 'data-src' ) );
                } );

                var url = $element.attr( 'data-src' );
                ImageCache.saveAndAply( url, $element, errorHandler404 );
            } );
        }else{
            $( imgTag ).each( function( id, item ){
                var $element = $( item );

                $element.attr( 'src', $element.attr( 'data-src' ) );
            } );
        }
    },

    saveAndAply : function( url, $element, errorHandler404, filename_extension ){

        var module = false;

        var testModules = /image.php\/(_s\/)?.*?\/(.*?)\/-?\d+\//.exec( url );
        if( testModules && testModules[ 2 ] ){

            if( module = ImageCache.allModules[ testModules[ 2 ] ] ){
                console.log( module );
                if( module.monologo_ext ){
                    url                = module.monologo_url;
                    filename_extension = module.monologo_ext;
                }else if( module.icon_ext ){
                    url                = module.icon_url;
                    filename_extension = module.icon_ext;
                }
            }
        }

        if( !filename_extension ){
            url = url.replace( "_s/", "" );
            url = url.replace( "theme/image.php/", "local/kopere_mobile/theme_image.php/" );

            var extension_exec = /\.(jpg|jpeg|png|svg)/.exec( url );
            if( extension_exec && extension_exec[ 1 ] ){
                filename_extension = extension_exec[ 1 ];
                if( filename_extension == "jpeg" ){
                    filename_extension = "jpg";
                }
            }
        }
        var filename = ImageCache.__hashCode( url );

        // para poder testar no navegador
        if( typeof resolveLocalFileSystemURL == 'undefined' ){
            ImageCache.__imagemDefault( $element, url );
            return;
        }

        resolveLocalFileSystemURL( Offline.persistentPath, function( fileSystem ){

            if( filename_extension ){
                fileSystem.getFile( `${filename}.${filename_extension}`, { create : false },
                    fileExists,
                    fileDoesNotExist );
            }else{

                var saveFullPath  = false;
                var fileEntry     = false;
                const promise_jpg = new Promise( ( resolve, reject ) => {
                    fileSystem.getFile( `${filename}.jpg`, { create : false },
                        function( _fileEntry ){
                            fileEntry    = _fileEntry;
                            saveFullPath = `${fileSystem.nativeURL}${filename}.jpg`;

                            resolve();
                        }, resolve );
                } );
                const promise_png = new Promise( ( resolve, reject ) => {
                    fileSystem.getFile( `${filename}.png`, { create : false },
                        function( _fileEntry ){
                            fileEntry    = _fileEntry;
                            saveFullPath = `${fileSystem.nativeURL}${filename}.png`;

                            resolve();
                        }, resolve );
                } );
                const promise_svg = new Promise( ( resolve, reject ) => {
                    fileSystem.getFile( `${filename}.svg`, { create : false },
                        function( _fileEntry ){
                            fileEntry    = _fileEntry;
                            saveFullPath = `${fileSystem.nativeURL}${filename}.svg`;

                            resolve();
                        }, resolve );
                } );
                Promise.all( [ promise_jpg, promise_png, promise_svg ] ).then( function( values ){
                    if( saveFullPath ){
                        fileExists( fileEntry );
                    }else{
                        ImageCache.__baixarImagem( url, filename, filename_extension, $element, errorHandler404 );
                    }
                } );


            }
        }, requestFileFail );

        function fileExists( fileEntry ){
            var nativeURL = fileEntry.nativeURL;
            if( typeof window.Ionic == "object" && typeof window.Ionic.WebView == "object" ){
                nativeURL = window.Ionic.WebView.convertFileSrc( fileEntry.nativeURL );
            }

            $element
                .attr( 'src', nativeURL )
                .removeAttr( 'data-src' );
        }

        function fileDoesNotExist( fileEntry ){
            ImageCache.__baixarImagem_FileTransfer( url, filename, filename_extension, $element, errorHandler404 );
        }

        function requestFileFail( evt ){
            ImageCache.__imagemDefault( $element, url );
        }
    },

    __hashCode : function( str ){
        str = str.split( /[^0-9a-zA-Z]/ ).join( "" );

        var hash = 0;
        for( var i = 0; i < str.length; i++ ){
            hash += str.charCodeAt( i );
        }
        /*-*/
        hash += 3;
        /**/
        return "img_" + hash.toString( 36 );
    },

    __baixarImagem : function( url, filename, filename_extension, $element, errorHandler404 ){

        var preview = $element.attr( "data-preview" );
        //console.log( { url : url, filename : filename, filename_extension : filename_extension, preview : preview } );

        url = UrlUtil.addToken( url, preview );

        $.ajax( {
            url      : url,
            error    : function(){
                ImageCache.__imagemDefault( $element, url );
            },
            complete : function( resp ){
                if( (resp.status === 200 || resp.status === 0) ){
                    if( !filename_extension ){
                        // console.log ( resp.getAllResponseHeaders () );
                        var exec_filename = /image\/(\w+)/.exec( resp.getAllResponseHeaders() );
                        if( exec_filename && exec_filename[ 1 ] ){
                            filename_extension = exec_filename[ 1 ];
                            if( filename_extension == "jpeg" ){
                                filename_extension = "jpg";
                            }
                            console.log( "Extensão localizada: " + filename_extension );
                            ImageCache.__baixarImagem_FileTransfer( url, filename, filename_extension, $element, errorHandler404 );
                        }else{
                            ImageCache.__imagemDefault( $element, url );
                        }
                    }
                }else{
                    ImageCache.__imagemDefault( $element, url );
                }
            }
        } );
    },

    __baixarImagem_FileTransfer : function( url, filename, filename_extension, $element, errorHandler404 ){
        url = UrlUtil.addToken( url );

        console.log( `${Offline.persistentPath}${filename}.${filename_extension}` );

        var cacheTransfer = new FileTransfer();
        cacheTransfer.download(
            url,
            `${Offline.persistentPath}${filename}.${filename_extension}`,
            function( entry ){
                var nativeURL = entry.nativeURL;
                if( typeof window.Ionic == "object" && typeof window.Ionic.WebView == "object" ){
                    nativeURL = window.Ionic.WebView.convertFileSrc( entry.nativeURL );
                }
                ImageCache.__imagemDefault( $element, nativeURL );

                console.log( entry );
                console.log( cacheTransfer );
            },
            function( error ){
                ImageCache.__imagemDefault( $element, url );
                console.error( error );
                window[ errorHandler404 ] && window[ errorHandler404 ]( $element, error );
            },
            false, { headers : {} }
        );
    },

    __imagemDefault : function( $element, url ){
        $element.attr( 'src', url );
        $element.removeAttr( 'data-src' );
    },
};