PageOpen = {
    pushPage : function( page, title, callback, anim ){

        function __callback(){

            var event = new CustomEvent( "pageopen_pushpage_complete", {
                page  : page,
                title : title
            } );
            document.dispatchEvent( event );

            callback && callback();
        }

        if( anim ){
            document.getElementById( 'page-home' ).pushPage( page, {
                data      : { title : title },
                animation : anim,
                callback  : __callback
            } );
        }else{
            document.getElementById( 'page-home' ).pushPage( page, {
                data     : { title : title },
                callback : __callback
            } );
        }
    },

    timeoutID : 0,
    showModal : function( element_id ){
        var element = document.getElementById( element_id );
        if( element ){
            element.show();

            clearTimeout( PageOpen.timeoutID );
            PageOpen.timeoutID = setTimeout( function(){
                element.hide();
            }, 4000 );
        }
    },

    hideModal : function( element_id ){
        $( "ons-modal" ).hide();
    },

    showDialog : function( element_id ){
        var dialog = document.getElementById( element_id );

        if( dialog ){
            dialog.show();
        }else{
            ons.createElement( 'dialog.html', { append : true } )
                .then( function( dialog ){
                    dialog.show();
                } );
        }
    },

    hideDialog : function(){
        $( "ons-dialog" ).hide();
    }
};