function FormatCards_smartlms(){
    this.randonClass = StringUtil.randonKey();

    this.showTitle = function( title ){
        $( `.${this.randonClass} .toolbar__title` ).html( title );
    };

    this.show_course_detalhe_success = function( parent ){
        var _this = this;

        $( "#page-format-cards:not(.class-ok)" )
            .addClass( "class-ok" )
            .addClass( "formatcards-smartlms" )
            .addClass( this.randonClass );

        $( `.${_this.randonClass} .headerdisplaymultipage` ).html( "" );
        $( `.${_this.randonClass} .not-headerdisplaymultipage` ).html( "" );

        var iterate = $.each( FormatCards.core_course_get_contents, function( i, section ){
            $.each( FormatCards.format_card_structure.structures, function( i, structure ){
                if( section.id == structure.id ){
                    _this.showSection( section, structure, parent );
                }
            } );
        } );

        $.when( iterate ).done( function(){

            $( `.${_this.randonClass} .description  br:first-child:last-child` ).remove();
            $( `.${_this.randonClass} .description div:empty` ).remove();
            $( `.${_this.randonClass} .description   p:empty` ).remove();

            var videos = $( `.${_this.randonClass} .description` ).find( "video,audio" );
            if( videos.length ){
                videos.each( function( id, element ){
                    var videoClass = StringUtil.randonKey();
                    $( element ).addClass( `video-player-${videoClass}` );
                    new Plyr( `.video-player-${videoClass}` );
                } );
            }
        } );
    };

    this.showSection = function( section, structure, parent ){
        var _this = this;

        if( !section.visible ) return;
        if( !section.uservisible ) return;

        //if( structure.headerdisplaymultipage && parent == 0 ){
        _this.showSection_itens( section );
        if( structure.headerdisplaymultipage && parent == 0 ){
            var style = `
                    <style>
                        #section-${section.id} {
                            display  : block   !important;
                            height   : initial !important;
                            opacity  : 1       !important;
                        }
                    </style>`;

            $( `.${_this.randonClass} .not-headerdisplaymultipage` ).append( style );
        }
        //}else{
        _this.showSection_card( section, structure, parent );
        //}
    };

    this.showSection_card = function( section, structure, parent ){
        var _this = this;

        // if( structure.parent == parent ){
        if( structure.image ){

            var $block2 = $( `
                        <div class="blocks blocks-smartlms" id="blocks-${section.id}">
                            <a class="blocks-main-content">
                                <div class="blocks-img-top"></div>
                                <div class="blocks-header-fade"></div>
                                <div class="blocks-title">${section.name}</div>
                            </a>
                        </div>
                        <style>
                            #section-${section.id} {
                                display : none;
                            }
                        </style>` );

            $( `.${_this.randonClass} .not-headerdisplaymultipage` ).append( $block2 );

            $block2.click( function(){
                console.log( `#section-${section.id}` );

                $( `#course-cards-content .section` ).hide( 300 );
                $( `#section-${section.id}` ).show( 300 );
            } );

            if( structure.image.indexOf( "data:image" ) == 0 ){
                $( `#blocks-${section.id} .blocks-img-top` ).css( { backgroundImage : structure.image } );
            }else{
                var fullurl_token = UrlUtil.addToken( structure.image );
                FileCache.saveAndGet( fullurl_token, { offline_key : CourseUtil.course_selected.id },
                    function( localUrl ){
                        $( `#blocks-${section.id} .blocks-img-top` ).css( { backgroundImage : `url('${localUrl}')` } );
                    },
                    function(){
                        $( `#blocks-${section.id} .blocks-img-top` ).css( { backgroundImage : `url('${fullurl_token}')` } );
                    } );
            }
        }
        //else{
        //    _this.showSection_itens( section );
        //}
        // }
    };

    this.showSection_itens = function( section ){
        var _this = this;

        if( !section.visible ) return;
        if( !section.uservisible ) return;

        var $block = $( `<ons-card id="section-${section.id}" class="section"></ons-card>` );

        if( section.name.trim() ){
            $block.append( `<h2 class='title-course'>${section.name}</h2>` )
        }
        if( section.summary ){
            var $summary = $( `<div class='summary'>${section.summary}</div>` );

            $block.append( $summary );
            HtmlUtil.validate( $summary );
        }

        $block.append( `<div id="modules-area-${section.id}" class="modules-area"></div>` );

        $( `.${_this.randonClass} .headerdisplaymultipage` ).append( $block );

        // console.log ( section.modules );
        $.each( section.modules, function( id, module ){
            ModuleOpen.renderer( section, module, false )
        } );
    };
}
