FormatTopics = {

    core_course_get_contents : null,

    show_course_detalhe : function(){
        ModMakeView.call( {
            module_id  : CourseUtil.module_selected.id,
            courseid   : CourseUtil.course_selected.id,
            wsfunction : "core_course_view_course"
        }, false, false );

        FormatTopics.load_course_detalhe();

        $( "#page-format-topics .page__content" ).scroll( function(){
            var top = $( "#page-format-topics .page__content" ).scrollTop();

            $( "#page-format-topics .toolbar__title, #page-format-topics .toolbar .background" ).css( {
                opacity : top / 200
            } );
        } );
    },

    load_course_detalhe : function(){

        if( !document.getElementById( 'page-format-topics' ) ) {

            return;
        }

        var data = {
            courseid    : CourseUtil.course_selected.id,
            options     : [
                { name : "excludemodules", value : 0 },
                { name : "excludecontents", value : 0 },
                { name : "includestealthmodules", value : 1 }
            ],
            wsfunction  : "core_course_get_contents",
            offline_key : CourseUtil.course_selected.id
        };
        DataLoad.loadWebserviceOfflineData( data, FormatTopics.load_course_detalhe_success, null, true );
    },

    load_course_detalhe_success : function( data ){
        console.log(data);
        FormatTopics.core_course_get_contents = data;

        $( "#page-format-topics .toolbar .toolbar__left" ).before( "<div class='background'></div>" );
        $( "#page-format-topics .toolbar .toolbar__title" ).html( CourseUtil.course_selected.fullname );

        if( !data.error ){

            $( "#course-topics-content" ).html( `
                    <div id='course-topo'>
                        <div class="titulos"></div>
                        <div class="d-flex"></div>
                    </div>
                    <div id='course-sections'></div>` );
            FormatTopo.createTopo();

            var iterate = $.each( data, FormatTopics.showSection );

            $.when( iterate ).done( function(){

                $( "#page-format-topics .description  br:first-child:last-child" ).remove();
                $( "#page-format-topics .description div:empty" ).remove();
                $( "#page-format-topics .description   p:empty" ).remove();

                var videos = $( "#page-format-topics .description" ).find( "video,audio" );
                if( videos.length ){
                    videos.each( function( id, element ){
                        var videoClass = StringUtil.randonKey();
                        $( element ).addClass( `video-player-${videoClass}` );
                        new Plyr( `.video-player-${videoClass}` );
                    } );
                }
            } );

        }else{

            console.trace( `Erro: ${data.error}` );
            ons.notification.toast( `Erro: ${data.error}`, {
                buttonLabel : 'OK',
                timeout     : 1500
            } );
        }
    },

    showSection : function( key, section ){
        // console.table ( section );

        if( !section.visible ) return;
        if( !section.uservisible ) return;
        if( section.modules.length == 0 ) return;

        if( document.getElementById( `section-${section.id}` ) ){
            $( `#section-${section.id}` ).remove();
        }

        var $section = $( `<ons-card id="section-${section.id}" class="section"></ons-card>` );
        $( "#course-sections" ).append( $section );

        if( section.name.trim() ){
            $section.append( `<h2 class='title-course'>${section.name}</h2>` )
        }
        if( section.summary ){
            var $summary = $( `<div class='summary'>${section.summary}</div>` );

            $section.append( $summary );
            HtmlUtil.validate( $summary );
        }

        $section.append( `<div id="modules-area-${section.id}" class="modules-area"></div>` );

        $.each( section.modules, function( id, module ){
            ModuleOpen.renderer( section, module, true )
        } );
    }
};

document.addEventListener( "modmakeview_loaded", FormatTopics.load_course_detalhe );
document.addEventListener( "course_reloaded", FormatTopics.load_course_detalhe );
