ModuleOpen = {

    allModules : {},

    renderer : function( section, module, showLink ){
        //console.log ( { metodo : "ModuleOpen::renderer", parametros : [ section, module ] } );

        ModuleOpen.allModules[ module.id ] = module;

        if( module.modname == "smtcollapse" ){
            console.log( "ignore module.modname == \"smtcollapse\"" );
            return;
        }

        if( !module.visible ){
            console.log( "ignore !module.visible" );
            return;
        }

        var module_class = "";
        if( ImageCache.allModules && ImageCache.allModules[ module.modname ] && ImageCache.allModules[ module.modname ].mod_purpose ){
            var mod_purpose = ImageCache.allModules[ module.modname ].mod_purpose;
            module_class    = `mod_purpose-icon mod_purpose-icon--${mod_purpose}`;
        }

        var module_modicon = module.modicon;
        if( ImageCache.allModules[ module.modname ] && ImageCache.allModules[ module.modname ].cache_src ){
            module_modicon = ImageCache.allModules[ module.modname ].cache_src;
        }

        var extra = "";
        /*-*/
        extra = `<i>module: ${module.modname}</i><br>`;
        /**/
        var $module = $( `
                <ons-card id="module-${module.id}" class="module mod_${module.modname}">
                    <div class="d-flex">
                        <div class="mod_purpose ${module_class}">
                            <img id="module-icon-${module.id}"
                                 class="module-image src-to-datasrc"
                                 onerror="this.src='img/extra/pix-2x2.png'"
                                 src="${module_modicon}"
                                 data-preview="150">
                        </div>
                        <div class="title">${extra}${module.name}</div>
                        <div class="info"></div>
                    </div>
                </ons-card>` );

        $( `#modules-area-${section.id}` ).append( $module );

        if( module.visibleoncoursepage && module.description ){
            var description = module.description.split( " src" ).join( " data-src" );

            var $description = $( `<div class="description">${description}</div>` );
            $description.find( "input" ).remove();
            $description.find( "button" ).remove();
            $description.find( ".mod-pictures-modal-container" ).remove();
            //$description.find( "img" ).each( function( id, element ){
            //    var $img = $( this );
            //    if( newSrc = $img.attr( "src" ) ){
            //        newSrc = UrlUtil.addToken( newSrc );
            //        $img.attr( "src", newSrc );
            //    }
            //} );

            if( module.modname == "pictures" ){
                $description.find( ".card" ).removeClass( "card" );
            }

            var videos = $description.find( "video,audio,video source,audio source" );
            videos.each( function( id, element ){
                var $element = $( element );
                if( src = $element.attr( "src" ) ){
                    src = UrlUtil.addToken( src );
                    $element.attr( "src", src );
                }else if( datasrc = $element.attr( "data-src" ) ){
                    datasrc = UrlUtil.addToken( datasrc );
                    $element.attr( "src", src );
                }
            } );

            $module.append( $description );
            HtmlUtil.validate( $description );
        }

        if( module.modname != "label" ){
            if( module.availabilityinfo ){
                $module.addClass( "disabled" );

                if( !showLink ){
                    module.availabilityinfo = module.availabilityinfo.replace( "<a", "<span" );
                    module.availabilityinfo = module.availabilityinfo.replace( "</a>", "</span>" );
                }
                var $availabilityinfo = $( `<div class="availabilityinfo">${module.availabilityinfo}</div>` );
                $availabilityinfo.find( "a" )
                    .addClass( "href-to-external" )
                    .click( function(){
                        event.stopImmediatePropagation();
                        event.preventDefault();

                        var href = $( this ).attr( "href" );
                        console.log( href );

                        var maches = /mod\/.*?\/.*?\.php\?id=(\d+)/.exec( href );
                        if( maches && maches[ 1 ] ){

                            var $element = $( `#module-${maches[ 1 ]}` );
                            if( $element.length ){
                                $element.addClass( "animate-color" );
                                setTimeout( function(){
                                    $element.removeClass( "animate-color" );
                                }, 300 );
                                setTimeout( function(){
                                    $element.addClass( "animate-color" );
                                    setTimeout( function(){
                                        $element.removeClass( "animate-color" );
                                        window.location.hash = `#`;
                                    }, 300 );
                                }, 300 + 200 );

                                $( '#page-format-topics .content' ).animate( {
                                    scrollTop : $element[ 0 ].offsetTop
                                }, 400 );
                            }
                            //else {
                            //    ons.notification.toast ( `Não foi possível localizar o módulo.`, {
                            //        buttonLabel : 'OK',
                            //        timeout     : 1500
                            //    } );
                            //}
                        }
                    } );
                $module.append( $availabilityinfo );
            }

            /**
             * 0 => Não indicar a conclusão de atividade
             * 1 => Os estudantes podem marcar manualmente a atividade como concluída
             * 2 => Mostrar atividade como concluída quando as condições forem satisfeitas
             */
            if( module.completion == 1 ){
                var $completionInfo = "";
                if( module.completiondata.state ){
                    $completionInfo = $(
                        `<img class="completion-info completion-info-y"
                              src="img/completion/completion-manual-y.svg"
                              data-y="img/completion/completion-manual-y.svg"
                              data-n="img/completion/completion-manual-n.svg">` );
                }else{
                    $completionInfo = $(
                        `<img class="completion-info completion-info-n"
                              src="img/completion/completion-manual-n.svg"
                              data-y="img/completion/completion-manual-y.svg"
                              data-n="img/completion/completion-manual-n.svg">` );
                }
                if( $completionInfo ){
                    $module.find( ".d-flex .info" ).append( $completionInfo );
                    $completionInfo.click( function(){
                        event.stopImmediatePropagation();
                        event.stopPropagation();

                        // 1 => COMPLETION_COMPLETE
                        // 0 => COMPLETION_INCOMPLETE
                        var data = {
                            wsfunction : "core_completion_update_activity_completion_status_manually",
                            cmid       : module.id,
                        };
                        if( $completionInfo.attr( "src" ).indexOf( "-n" ) > 1 ){
                            var dataY = $completionInfo.attr( "data-y" );
                            $completionInfo.attr( "src", dataY );
                            data.completed = 1;
                        }else{
                            var dataN = $completionInfo.attr( "data-n" );
                            $completionInfo.attr( "src", dataN );
                            data.completed = 0;
                        }
                        DataLoad.loadWebserviceOfflineData( data );
                    } );
                }

            }
            else if( module.completion == 2 && module.completiondata ){
                if( module.completiondata.state ){
                    $module.find( ".d-flex .info" ).append(
                        `<img class="completion-info completion-info-y"
                              src="img/completion/completion-auto-y.svg">` );
                }else{
                    $module.find( ".d-flex .info" ).append(
                        `<img class="completion-info completion-info-n"
                              src="img/completion/completion-auto-n.svg">` );
                }
            }else{
                $module.find( ".d-flex .info" ).append(
                    `<span class="no-completion-info"></span>` );
            }

            ModuleOpen.showOfflineButton( $module, module );

            if( module.uservisible ){
                $module.click( function(){
                    CourseUtil.section_selected = section;
                    ModuleOpen.module_click( module );
                } );
            }else{
                $module.addClass( "disabled" );
            }
        }

        HtmlUtil.validate( $module );
    },

    showOfflineButton_cache : {},
    showOfflineButton       : function( $module, module ){
        var ModClass = CourseUtil.mods[ module.modname ];
        if( ModClass && !ModClass.make_offline_disables ){
            // console.log( "Botão Baixar " + module.modname + " - " + module.name );
            var $html = $( `
                    <div id="offline-status-module-${module.id}" class="offline-status">
                        <ons-icon icon="ion-md-cloud-download" class="offline-download" size="34px" style="display:none"></ons-icon>
                        <ons-icon icon="ion-md-cloud-done"     class="offline-done"     size="34px" style="display:none"></ons-icon>
                    </div>` );
            $html.click( function(){
                // event.stopImmediatePropagation();
                // event.preventDefault();
            } );
            $module.find( ".d-flex .info" ).append( $html );

            if( ModuleOpen.showOfflineButton_cache[ module.id ] ){
                $( `#offline-status-module-${module.id} .offline-done` ).show();
            }else{
                var promise = ModClass.make_offline__status( CourseUtil.course_selected, module );
                promise.then(
                    function( value ){
                        ModuleOpen.showOfflineButton_cache[ module.id ] = 1;
                        $( `#offline-status-module-${module.id} .offline-done` ).show();
                    },
                    function( reason ){
                        $( `#offline-status-module-${module.id} .offline-download` ).show();
                    }
                );
            }
        }
    },

    module_click : function( module ){
        if( module ){
            if( module.availabilityinfo ){
                var availabilityinfo = module.availabilityinfo;
                availabilityinfo     = availabilityinfo.split( "<a " ).join( "<strong " );
                availabilityinfo     = availabilityinfo.split( "</a>" ).join( "</strong>" );
                console.trace( availabilityinfo );
                ons.notification.toast( availabilityinfo, {
                    buttonLabel : 'OK',
                    timeout     : 1500
                } );
            }else{
                CourseUtil.module_selected = module;

                if( CourseUtil.mods[ module.modname ] ){
                    var ModClass = CourseUtil.mods[ module.modname ];
                    ModClass.load_page();
                }else{
                    OpenUrl.open_external_logged( module.url );
                }
            }
        }else{
            ons.notification.toast( "Erro ao localizar o módulo, ou módulo não está disponível!", {
                buttonLabel : 'OK',
                timeout     : 1500
            } );
        }
    },

    statusDownload : function(){

        // course-baixar
        // course-progress
        // course-done

        var $statusDownload = $( `#status-download-${CourseUtil.course_selected.id}` );
        $statusDownload.find( ".course-done" ).click( function(){
            DownloadCourse.apagarCurso();
        } );

        $statusDownload.find( ".course-baixar" ).click( DownloadCourse.download );

        var successCallback = function( data ){
            if( data == "done" ){
                DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-done" );
            }else if( DownloadCourse.status[ CourseUtil.course_selected.id ] == "progress" ){
                DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-progress", 0 );
            }else{
                DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-baixar" );
            }
        };
        var errorCallback   = function(){
            DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-baixar" );
        };

        var key = `course-offline-${CourseUtil.course_selected.id}`;
        Offline.getOfflineById( key, successCallback, errorCallback )
    }
};