CourseList = {

    config : {},

    selected   : null,
    categories : null,
    courses    : null,

    loadCursos : function(){

        var html_user = `
                <div class="user-info-space">
                     <img id="user-info-imagem" alt="${UserClass.fullname}">
                     <div id="user-info-nome">${UserClass.fullname}</div>
                 </div>`;
        $( `#user-info` ).html( html_user );

        var userpictureurl = UrlUtil.addToken( UserClass.userpictureurl, 100 );
        $( "#user-info-imagem" )
            .attr( "src", userpictureurl )
            .attr( "data-src", userpictureurl );

        ImageCache.saveAndAplyByTag( "#user-info-imagem" );

        $( "#home-tabbar .tabbar__content" ).removeClass( "tabbar--top__content" );
        $( "#home-tabbar .tabbar" ).removeClass( "tabbar--top" );

        var data = {
            section    : "frontpagesettings",
            wsfunction : "tool_mobile_get_config",
        };
        DataLoad.loadWebserviceOfflineData( data, CourseList.tool_mobile_get_config_success, null, true );
    },

    tool_mobile_get_config_success : function( config ){
        CourseList.config = {};
        $.each( config.settings, function( id, setting ){
            CourseList.config[ setting.name ] = setting.value;
        } );

        CourseList.config.frontpageloggedin = "2,5,6";

        var data = {
            addsubcategories : 1,
            wsfunction       : "core_course_get_categories",
        };
        DataLoad.loadWebserviceOfflineData( data, CourseList.core_course_get_categories_success, null, true );
    },

    core_course_get_categories_success : function( categories ){
        var data = {
            userid     : UserClass.userid,
            wsfunction : "core_enrol_get_users_courses",
        };
        DataLoad.loadWebserviceOfflineData( data, CourseList.core_enrol_get_users_courses_success, null, true );

        CourseList.categories = categories.sort( function( a, b ){
            var x = a.sortorder;
            var y = b.sortorder;
            return ((x < y) ? -1 : ((x > y) ? 1 : 0));
        } );
    },

    core_enrol_get_users_courses_success : function( courses ){
        CourseList.courses = courses;

        //console.log ( "show_success" );
        //console.table ( CourseList.courses );

        if( !CourseList.courses.error ){

            // "id":119
            // "shortname":"promotor_eletro"
            // "fullname":"Promotor de Vendas Eletro"
            // "displayname":"Promotor de Vendas Eletro"
            // "enrolledusercount":562
            // "idnumber":""
            // "visible":1
            // "summary":""
            // "summaryformat":1
            // "format":"cards"
            // "showgrades":false
            // "lang":""
            // "enablecompletion":true
            // "completionhascriteria":true
            // "completionusertracked":true
            // "category":2
            // "progress":1.7857142857142856
            // "completed":false
            // "startdate":1658804400
            // "enddate":0
            // "marker":0
            // "lastaccess":1676423198
            // "isfavourite":false
            // "hidden":false
            // "overviewfiles":{
            //      "fileurl":"https:\/\/url-moodle\/webservice\/pluginfile.php\/1735\/course\/overviewfiles\/ELETRO%20PROMOTORA.jpg"

            if( CourseList.courses.length ){
                $( "#page-course-list-content" ).html( "" );

                // frontpageloggedin
                //   0 => Avisos              => não implementado
                //   2 => Lista de categorias => Caso ativo substitui o Cursos inscritos
                //   4 => Menu Drop-down      => não implementado
                //   5 => Cursos inscritos    => Default
                //   6 => Lista de cursos     => não implementado
                //   7 => Caixa de pesquisa   => não implementado
                if( CourseList.config.frontpageloggedin.indexOf( "2" ) != -1 ){
                    $.each( CourseList.categories, function( key, category ){

                        var coursesCategories = [];
                        var iterate           = $.each( CourseList.courses, function( key, course ){
                            if( course.category == category.id ){
                                coursesCategories.push( course );
                            }
                        } );
                        $.when( iterate ).done( function(){
                            if( coursesCategories.length ){
                                var $category = $( `
                                    <ons-card id="category-${category.id}" class="category-item" modifier="category">
                                        <h3>${category.name}</h3>
                                        <div class="course-itens"></div>
                                    </ons-card>` );

                                $( "#page-course-list-content" ).append( $category );

                                $.each( coursesCategories, CourseList.showCurso );

                                $category.click( function( event ){
                                    $( event.target ).parent()
                                        .toggleClass( "collapsed" )
                                        .find( ".course-itens" ).toggle( 300 );
                                } )
                            }
                        } );
                    } );
                }else{
                    $.each( CourseList.courses, CourseList.showCurso );
                }
            }else{
                $( "#page-course-list-content" )
                    .html( `<div class="alert alert-warning alert-margin">Nenhum curso disponível!</div>` );
            }

            var event = document.createEvent( 'CustomEvent' );
            event.initCustomEvent( 'CourseList_update', true, true, {} );
            document.dispatchEvent( event );

        }else{
            Login.show();
            $( "#page-home" ).hide();
        }
    },

    showCurso : function( key, course ){

        var extra = "";
        /*-*/
        extra = `<div><strong>Curso ID:</strong> ${course.id}</div>
                 <div><strong>Formato:</strong> ${course.format}</div>`;
        /**/
        var $course;
        if( course.overviewfiles && course.overviewfiles[ 0 ] && course.overviewfiles[ 0 ].fileurl ){
            if( PublicConfig.customizationapphome == 'background' ){

                var image1, blockclass = "";
                if( PublicConfig.customfieldpicture[ course.id ] ){
                    image1     = PublicConfig.customfieldpicture[ course.id ].cache_src;
                    blockclass = "background-app";
                }else{
                    image1     = UrlUtil.addToken( course.overviewfiles[ 0 ].fileurl, 600 );
                    blockclass = "background-course";
                }

                var course_display = "";
                if( PublicConfig.block_myoverview_hidden_course[ course.id ] ){
                    course_display = "display:none";
                }
                $course = $( `
                    <ons-card id="courseid-${course.id}" class="course-item-background ${blockclass}" modifier="chevron"
                              style="background-image:url(${image1});${course_display}">
                        <div class="title-area">
                            <div class="title">
                                ${course.fullname}
                                ${extra}
                            </div>
                        </div>
                        <div class="course-item-background-ratio">&nbsp;</div>
                    </ons-card>` );
            }else{
                var image2 = UrlUtil.addToken( course.overviewfiles[ 0 ].fileurl, 150 );

                var course_display2 = "";
                if( PublicConfig.block_myoverview_hidden_course[ course.id ] ){
                    course_display2 = "display:none";
                }

                $course = $( `
                    <ons-card id="courseid-${course.id}" class="course-item" modifier="chevron" style="${course_display2}">
                        <div class="d-flex">
                            <img id="course-image-${course.id}" class="course-image" alt="Curso logo"
                                 src="img/extra/pix-9x19.png" data-src="${image2}"
                                 data-preview="200">
                            <div class="title-area">
                                <div class="title">${course.fullname}</div>
                                ${extra}
                            </div>
                        </div>
                    </ons-card>` );
            }
        }else{
            var course_display3 = "";
            if( PublicConfig.block_myoverview_hidden_course[ course.id ] ){
                course_display3 = "display:none";
            }
            $course = $( `
                    <ons-card id="courseid-${course.id}" class="course-item" modifier="chevron" style="${course_display3}">
                        <div class="d-flex">
                            <div class="title-area">
                                <div class="title">${course.fullname}</div>
                                ${extra}
                            </div>
                        </div>
                    </ons-card>` );
        }

        if( course.enablecompletion ){
            var progress  = Math.floor( course.progress );
            var $progress = `
                    <div class="progress-area">
                        <span>${progress}% concluído</span>
                        <ons-progress-bar value="${course.progress}"></ons-progress-bar>
                    </div>`;
            $course.find( '.title-area' ).append( $progress );
        }

        $course.click( function(){
            CourseList.openCourse( course );
        } );

        if( document.getElementById( `category-${course.category}` ) ){
            $( `#category-${course.category} .course-itens` ).append( $course );
        }else{
            $( "#page-course-list-content" ).append( $course );
        }

        ImageCache.saveAndAplyByTag( `#course-image-${course.id}` );
    },

    openCourse : function( course ){
        CourseUtil.course_selected = course;

        if( course.format == "singleactivity" ){
            FormatSingleActivity.show_course_detalhe();
        }else if( course.format == "cards" ){
            PageOpen.pushPage( 'page/format/cards/index.html', course.fullname, FormatCards.show_course_detalhe );
        }else{
            PageOpen.pushPage( 'page/format/topics/index.html', course.fullname, FormatTopics.show_course_detalhe );
        }
    }
};
