Notas = {

    load_notas : function(){
        if( !Notas.load_notas__loaded ){
            Notas.show_notas();
        }
        Notas.load_notas__loaded = true;
    },

    show_notas : function(){

        var data = {
            wsfunction : "gradereport_overview_get_course_grades",
        };
        DataLoad.loadWebserviceOfflineData( data, Notas.show_notas_detalhe_success, null, true );
    },

    show_notas_detalhe_success : function( grades ){

        if( grades.grades.length ){
            $( "#lista-notas" ).html( "" );
            $.each( grades.grades, function( id, grade ){
                $.each( CourseList.courses, function( id, course ){
                    if( grade.courseid == course.id && course.showgrades ){
                        Notas.show_course( grade, course );
                        return false;
                    }
                } );
            } );
        }else{
            $( "#lista-notas" )
                .html( `<div class="alert alert-warning alert-margin">Nenhuma nota disponível!</div>` );
        }
    },

    show_course : function( grade, course ){
        var $course = $( `
                <ons-card class="course-grade-item" id="course-grade-item-${course.id}">
                    <div class="title">${course.fullname}</div>
                    <div class="course-grade-tabledata" id="course-grade-tabledata-${course.id}"></div>
                </ons-card>` );
        $( "#lista-notas" ).append( $course );

        $course.click( function(){
            $course.click( function(){
                CourseList.openCourse( course );
            } );
        } );

        var data = {
            courseid    : course.id,
            userid      : UserClass.userid,
            wsfunction  : "gradereport_user_get_grades_table",
            offline_key : course.id,
        };
        DataLoad.loadWebserviceOfflineData( data, function( grades_table ){
            Notas.show_course_notas( course, grades_table )
        }, null, false );
    },

    show_course_notas : function( course, grades_table ){
        if( grades_table.errorcode ){
            var error_html = `<div class="alert alert-error">${grades_table.message}</div>`;
            $( `#course-grade-tabledata-${course.id}` ).append( error_html );
        }else{
            $.each( grades_table.tables[ 0 ].tabledata, function( id, tabledata ){
                if( id == 0 ) return;

                if( tabledata.itemname ){
                    var extraClass = "";
                    if( tabledata.itemname.content.indexOf( "i/agg_sum" ) > 2 ){
                        extraClass = "agg_sum";
                        if( PublicConfig.lang == "pt_br_uni" ){
                            tabledata.itemname.content = `
                                 <span class="gradeitemheader">
                                     <img class="icon itemicon" src="page/home/notas/img/agg_sum.png">
                                     Total da disciplina
                                 </span>`
                        }else{
                            tabledata.itemname.content = `
                                 <span class="gradeitemheader">
                                     <img class="icon itemicon" src="page/home/notas/img/agg_sum.png">
                                     Total do curso
                                 </span>`
                        }
                    }

                    var $grade_item = $( `
                        <ons-list-item class="grade-table-item ${extraClass}">
                            <div class="d-flex">
                                <div class="itemname">${tabledata.itemname.content}</div>
                                <div class="grade">${tabledata.grade.content}</div>
                            </div>
                            <!--div>
                                Peso: ${tabledata.weight.content}
                                Intervalo: ${tabledata.range.content}
                                Intervalo: ${tabledata.contributiontocoursetotal.content}
                            </div-->
                        </ons-list-item>`.replace( /<a[^>]*>/g, '<span>' ).replace( /<\/a>/g, '</span>' ) );

                    $( `#course-grade-tabledata-${course.id}` ).append( $grade_item );
                    HtmlUtil.validate( $grade_item );
                }
            } );
        }
    }
};

document.addEventListener( 'prechange', function( event ){
    if( $( event.tabItem ).attr( "data-tab" ) == 2 ){
        Notas.load_notas();
    }
} );
