ModFolder = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/folder/index.html`, CourseUtil.module_selected.name, ModFolder.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                folderid   : CourseUtil.module_selected.instance,
                wsfunction : "mod_folder_view_folder"
            }, false, true );
        }
    },

    show_module_load : function(){

        var module = CourseUtil.module_selected;

        $( "#page-mod-folder .toolbar__title" ).html( module.name );

        var $module = $( "<ons-card></ons-card>" );
        if( module.description ){
            $module.append( `<div>${module.description}</div>` );
        }else if( module.intro ){
            $module.append( `<div>${module.intro}</div>` );
        }

        var $download = $( `<ons-button>Baixar tudo</ons-button>` );
        $module.append( $download );


        var space = `<ons-card><ons-list class="data-content"></ons-list></ons-card>`;
        $( "#page-mod-folder-content" )
            .html( $module )
            .append( space );

        $download.click( function(){
            var url = `${AppConfig.wwwroot_web}/mod/folder/download_folder.php?id=${module.id}`;
            OpenUrl.open_external_logged( url );
        } );

        $.each( module.contents, ModFolder.show_module_load__content );
    },

    show_module_load__content : function( id, content ){

        /**
         * filename : "OXFORD PICTURE DICTIONARY WORKBOOK.pdf"
         * fileurl : "https://training.richardsedu.com/pluginfile.php/OXFORD%20PICTURE%20DICTIONARY%20WORKBOOK.pdf"
         * mimetype : "application/pdf"
         */

        var icon = "file.png";
        if( ModFolder.testUrlVideo( content.filename ) ){
            icon = "video.png";
        }else if( ModFolder.testUrlAudio( content.filename ) ){
            icon = "audio.png";
        }else if( ModFolder.testUrlImage( content.filename ) ){
            icon = "image.png";
        }else if( ModFolder.testUrlPdf( content.filename ) ){
            icon = "pdf.png";
        }else if( ModFolder.testUrlDoc( content.filename ) ){
            icon = "doc.png";
        }else if( ModFolder.testUrlPpt( content.filename ) ){
            icon = "ppt.png";
        }else if( ModFolder.testUrlXls( content.filename ) ){
            icon = "xls.png";
        }

        var $html = $( `
            <ons-list-item>
                <div class="left">
                    <img class="list-item__thumbnail" src="page/mod/folder/img/${icon}">
                </div>
                <div class="center">
                    <span class="list-item__title">${content.filename}</span>
                    <span class="list-item__subtitle">${content.mimetype}</span>
                </div>
            </ons-list-item>` );

        $( "#page-mod-folder-content .data-content" ).append( $html );
        $html.click( function(){
            var url = UrlUtil.addToken( content.fileurl );
            OpenUrl.open_external_logged( url );
        } );
    },

    testUrlVideo : function( url ){
        var re      = /\.(mp4|avi|wav)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlAudio : function( url ){
        var re      = /\.(mp3|wav)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlImage : function( url ){
        var re      = /\.(png|jpg|jpeg|gif|ttf)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlPdf   : function( url ){
        console.log( url );
        var re      = /\.(pdf)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlDoc   : function( url ){
        var re      = /\.(doc|docx|odt)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlPpt   : function( url ){
        var re      = /\.(ppt|pptx)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlXls   : function( url ){
        var re      = /\.(xls|xlsx)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },

    make_offline_disables : true,
};

CourseUtil.mods[ "folder" ] = ModFolder;