ModPage = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/page/index.html`, CourseUtil.module_selected.name, ModPage.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                pageid     : CourseUtil.module_selected.instance,
                wsfunction : "mod_page_view_page"
            }, false, true );
        }
    },

    show_module_load : function(){
        var module = CourseUtil.module_selected;

        $( "#page-mod-page .toolbar__title" ).html( module.name );

        if( module.description || module.intro ){
            var $module = $( "<ons-card></ons-card>" );
            if( module.description ){
                $module.append( `<div>${module.description}</div>` );
            }else if( module.intro ){
                $module.append( `<div>${module.intro}</div>` );
            }
            console.log( $module );
            $( "#page-mod-page-content" ).html( $module );
        }else{
            $( "#page-mod-page-content" ).html( "" );
        }

        var customdata = JSON.parse( module.customdata );

        $.each( module.contents, function( id, content ){
            if( content.filename == "index.html" ){
                ModPage._show_file( content.fileurl );
            }
        } );
    },

    _show_file : function( fullurl ){
        var fullurl_token = UrlUtil.addToken( fullurl );

        FileCache.saveAndGet( fullurl_token, { offline_key : CourseUtil.course_selected.id },
            function( localUrl ){
                $.get( localUrl, function( html ){
                    ModPage._replace_internal_itens( html );
                } );
            },
            function(){
                PageOpen.showDialog( "page-erro-carregar-arquivo" );
                $( "#page-erro-carregar-arquivo .title"
                ).html( "Erro ao carregar o conteúdo da página!" );
            } );
    },

    _replace_internal_itens : function( html ){
        var module = CourseUtil.module_selected;

        var iterate = $.each( module.contents, function( id, content ){
            if( content.filename != "index.html" ){

                html = html.split( content.filename ).join( fullurl_token );
                html = html.split( encodeURIComponent( content.filename ) ).join( fullurl_token );
                html = html.split( StringUtil.encodeURIComponent( content.filename ) ).join( fullurl_token );
                html = html.split( StringUtil.encodeURIComponent( encodeURIComponent( content.filename ) ) ).join( fullurl_token );
            }
        } );

        $.when( iterate ).done( function(){
            var $html = $( `<ons-card>${html}</ons-card>` );
            $( "#page-mod-page-content" ).append( $html );
            HtmlUtil.validate( $html );

            $html.find( "video" ).each( function( id, videoElement ){
                var $videoElement = $( videoElement );
                var newClassVideo = StringUtil.randonKey();
                $videoElement.addClass( newClassVideo );

                new Plyr( `.${newClassVideo}` );
            } );
        } );
    },

    make_offline : function( course, module ){

        return new Promise( function( resolve, reject ){
            var fullurl = "";
            if( module.contents && [ 0 ] && module.contents[ 0 ].fileurl ){

                $.each( module.contents, function( id, content ){

                    var fullurl_token = UrlUtil.addToken( content.fileurl );

                    var data = { offline_key : CourseUtil.course_selected.id };
                    FileCache.saveAndGet( fullurl_token, data, resolve, reject );
                } );

            }else{
                var customdata = JSON.parse( module.customdata );
                if( customdata && customdata.fullurl ){
                    fullurl = customdata.fullurl;
                }
            }
        } );
    },

    make_offline__status : function( course, module ){
        return new Promise( function( resolve, reject ){
            var fullurl = "";
            if( module.contents && [ 0 ] && module.contents[ 0 ].fileurl ){

                $.each( module.contents, function( id, content ){

                    var fullurl_token = UrlUtil.addToken( content.fileurl );

                    var data = { offline_key : CourseUtil.course_selected.id };
                    FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
                } );

            }else{
                reject();
            }
        } );
    }
};


CourseUtil.mods[ "page" ] = ModPage;