ModPdfProtect = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/pdfprotect/index.html`, CourseUtil.module_selected.name, ModPdfProtect.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                modid      : CourseUtil.module_selected.instance,
                modname    : CourseUtil.module_selected.modname,
                wsfunction : "local_kopere_mobile_mod_make_view"
            }, false, true );
        }
    },

    show_module_load : function(){
        var module = CourseUtil.module_selected;
        $( "#page-mod-pdfprotect .toolbar__title" ).html( module.name );

        var module_html = `
            <div id="data-content-intro"></div>
            <div id="data-content-pdf" class="data-content-pdfprotect"></div>`;
        $( "#page-mod-pdfprotect-content" ).html( module_html );

        if( module.intro ){
            var $module_intro = $( `<ons-card>${module.intro}</ons-card>` );
            $( "#data-content-intro" ).html( $module_intro );

            HtmlUtil.validate( $module_intro );
        }else if( module.description ){
            var $module_description = $( `<ons-card>${module.description}</ons-card>` );
            $( "#data-content-intro" ).html( $module_description );

            HtmlUtil.validate( $module_description );
        }

        var fileurl       = module.contents[ 0 ].fileurl;
        fileurl           = decodeURIComponent( fileurl );
        fileurl           = `${fileurl}?sfgsdjfgkhjdsfhkjsdkfhgjsdfgkj=1`;
        var fullurl_token = UrlUtil.addToken( fileurl );
        console.log( fullurl_token );
        var data = {
            offline_key : CourseUtil.course_selected.id,
            module      : module,
        };
        FileCache.saveAndGet( fullurl_token, data,
            function( localUrl ){
                localUrl = encodeURIComponent( localUrl );
                $( `#data-content-pdf` ).html(
                    `<iframe id="module-embed-${module.id}" src="players/pdf/web/viewer.html?file=${localUrl}"
                                 allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                                 sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                                 style="height: 100%;width: 100%;" allowfullscreen frameborder="0"></iframe>` );
            },
            function(){
                // PageOpen.showDialog ( "pdfprotect-erro-carregar-arquivo" );
                $( `#data-content-pdf` ).html( "Erro ao carregar o PDF!" );
            }, ModPdfProtect.make_offline__baixar_pdfprotect__progress );
    },

    make_offline : function( course, module ){

        return new Promise( function( resolve, reject ){
            var fullurl;
            if( module.contents && module.contents[ 0 ] ){
                if( module.contents[ 0 ].fileurl ){
                    fullurl = module.contents[ 0 ].fileurl;
                }
            }

            fullurl = `${fullurl}?sfgsdjfgkhjdsfhkjsdkfhgjsdfgkj=1`;
            console.log( fullurl );
            var fullurl_token = UrlUtil.addToken( fullurl );

            var data = { offline_key : CourseUtil.course_selected.id };
            FileCache.saveAndGet( fullurl_token, data, resolve, reject );
        } );
    },

    make_offline__baixar_pdfprotect__progress : function( event, data ){
        if( !data || !data.module ) return;

        if( !document.getElementById( `progress-pdfprotect-download--${data.module.instance}` ) ){
            var progress = `
                <ons-card id="progress-pdfprotect-download--${data.module.instance}" modifier="category">
                    <ons-progress-bar value="0">Download do PDF<span>...</span></ons-progress-bar>
                </ons-card>`;
            $( "#data-content-pdf" ).append( progress );
        }

        var percentagem = event.loaded / event.total * 100;
        var loaded      = NumberFormat.formatBytes( event.loaded );
        var total       = NumberFormat.formatBytes( event.total );
        $( `#progress-pdfprotect-download--${data.module.instance} ons-progress-bar` )
            .attr( "value", percentagem )
            .find( "span" ).html( ` => ${loaded} de ${total}` );
    },

    make_offline__status : function( course, module ){

        return new Promise( function( resolve, reject ){
            var fullurl;
            if( module.contents && module.contents[ 0 ] && module.contents[ 0 ].fileurl ){
                fullurl = module.contents[ 0 ].fileurl;

                fullurl = `${fullurl}?sfgsdjfgkhjdsfhkjsdkfhgjsdfgkj=1`;
                console.log( fullurl );
                var fullurl_token = UrlUtil.addToken( fullurl );

                var data = { offline_key : CourseUtil.course_selected.id };
                FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
            }else{
                reject();
            }
        } );
    },
};

CourseUtil.mods[ "pdfprotect" ]    = ModPdfProtect;
CourseUtil.mods[ "smtpdfprotect" ] = ModPdfProtect;