ModResource = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/resource/index.html`, CourseUtil.module_selected.name, ModResource.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                resourceid : CourseUtil.module_selected.instance,
                wsfunction : "mod_resource_view_resource"
            }, false, true );
        }
    },

    show_module_load : function(){

        var module = CourseUtil.module_selected;

        var data = {
            courseids   : [ CourseUtil.course_selected.id ],
            wsfunction  : "mod_resource_get_resources_by_courses",
            offline_key : CourseUtil.course_selected.id
        };
        DataLoad.loadWebserviceOfflineData( data, function( data ){

            console.log( { module : module } );
            console.log( { resources : data.resources } );
            $.each( data.resources, function( id, resource ){
                if( resource.id == module.instance ){
                    ModResource.mod_resource_get( resource );

                    /*
                    "contentfiles": [
                    {
                        "filename": "progresso.pdf",
                        "fileurl": "https://yduqs-homolog.smartlms.com.br/webservice/pluginfile.php/223570/mod_resource/content/0/progresso.pdf",
                        "mimetype": "application/pdf",
                    }
                    */
                }
            } )

        }, null, true );
    },

    mod_resource_get : function( resource ){

        var module = CourseUtil.module_selected;
        $( "#page-mod-resource .toolbar__title" ).html( module.name );
        $( "#page-mod-resource-content" ).html( "" );

        var module_html = "";
        if( resource.intro ){
            $( "#page-mod-resource-content" ).append( `<ons-card>${resource.intro}</ons-card>` );
        }

        $.each( resource.contentfiles, function( file_id, contentfile ){

            var $module_html = $( `<div id="data-content-${module.instance}-${file_id}" class="data-content-resource"></div>` );
            $( "#page-mod-resource-content" ).append( $module_html );
            HtmlUtil.validate( $module_html );

            ModResource.show_contentfile( file_id, contentfile );
        } );
    },

    show_contentfile : function( file_id, contentfile ){
        var fullurl  = "";
        var mimetype = "";
        if( contentfile.mimetype ){
            mimetype = contentfile.mimetype;
        }
        if( contentfile.fileurl ){
            fullurl = contentfile.fileurl;
        }else{
            fullurl = mimetype = "";
        }

        var module        = CourseUtil.module_selected;
        var fullurl_token = UrlUtil.addToken( fullurl );

        if( mimetype == "application/pdf" ){
            var data = {
                offline_key : CourseUtil.course_selected.id,
                module      : module,
            };
            FileCache.saveAndGet( fullurl_token, data,
                function( localUrl ){
                    console.log( localUrl );
                    console.log( `#data-content-${module.instance}-${file_id}` );
                    localUrl = encodeURIComponent( localUrl );
                    $( `#data-content-${module.instance}-${file_id}` ).html(
                        `<iframe id="module-embed-${module.id}" src="players/pdf/web/viewer.html?file=${localUrl}"
                                 allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                                 sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                                 width="100%" height="100%" allowfullscreen frameborder="0"></iframe>` );
                },
                function( error ){
                    console.log( error );
                    // PageOpen.showDialog ( "resource-erro-carregar-arquivo" );
                    $( `#data-content-${module.instance}-${file_id}` ).html( "Erro ao carregar o PDF!" );
                },
                ModResource.make_offline__baixar_resource__progress );
        }
        else if( mimetype == "audio/mp3" ){

            $( `#data-content-${module.instance}-${file_id}` ).html(
                `<audio id="module-embed-${module.id}" src="${fullurl_token}" width="100%" height="315" controls></audio>` );

            window.plyr = new Plyr( `#module-embed-${module.id}` );
        }
        else if( mimetype == "video/mp4" ){

            $( `#data-content-${module.instance}-${file_id}` ).html(
                `<video id="module-embed-${module.id}" src="${fullurl_token}" width="100%" height="315" controls></video>` );

            window.plyr = new Plyr( `#module-embed-${module.id}` );
        }
        else if( mimetype.indexOf( "image/" ) === 0 ){

            $( `#data-content-${module.instance}-${file_id}` ).html(
                `<img id="module-embed-${module.id}"
                      src="img/extra/pix-9x19.png" data-src="${fullurl_token}"
                      width="100%" data-preview="150"/>` );

            ImageCache.saveAndAplyByTag( `#module-embed-${module.id}` );
        }
        else{
            var $button = $( `<ons-card><ons-button modifier="large" class="button-margin">Abrir "${contentfile.filename}" no navegador</ons-button></ons-card>` );
            $( `#data-content-${module.instance}-${file_id}` ).html( $button );
            $button.click( function(){
                fullurl = fullurl.replace( "/webservice/", "/" );
                OpenUrl.open_external_logged( fullurl );
            } );
        }
    },


    make_offline : function( course, module ){

        return new Promise( function( resolve, reject ){

            var data = {
                courseids   : [ CourseUtil.course_selected.id ],
                wsfunction  : "mod_resource_get_resources_by_courses",
                offline_key : CourseUtil.course_selected.id
            };
            DataLoad.loadWebserviceOfflineData( data, function( data ){

                $.each( data.resources, function( id, resource ){

                    if( resource.id = module.instance ){
                        var fullurl;
                        var mimetype;
                        if( resource.contentfiles && resource.contentfiles[ 0 ] ){
                            if( resource.contentfiles[ 0 ].mimetype ){
                                mimetype = resource.contentfiles[ 0 ].mimetype;
                            }else{
                                mimetype = "";
                            }
                            if( resource.contentfiles[ 0 ].fileurl ){
                                fullurl = resource.contentfiles[ 0 ].fileurl;
                            }else{
                                fullurl = mimetype = "";
                            }
                        }
                        else{
                            fullurl = mimetype = "";
                        }

                        var fullurl_token = UrlUtil.addToken( fullurl );
                        var data          = { offline_key : CourseUtil.course_selected.id };
                        if( mimetype == "application/pdf" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject );
                        }
                        else if( mimetype == "audio/mp3" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject );
                        }
                        else if( mimetype == "video/mp4" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject );
                        }
                        else if( mimetype.indexOf( "image/" ) === 0 ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject );
                        }
                        else{
                            resolve();
                        }
                    }else{
                        resolve();
                    }
                } )

            }, null, true );
        } );
    },

    make_offline__baixar_resource__progress : function( event, data ){
        if( !document.getElementById( `progress-resource-download--${data.module.instance}` ) ){
            var progress = `
                <ons-card id="progress-resource-download--${data.module.instance}" modifier="category">
                    <ons-progress-bar value="0">Download do PDF<span>...</span></ons-progress-bar>
                </ons-card>`;
            $( `#data-content-${data.module.instance}-0` ).append( progress );
        }

        var percentagem = event.loaded / event.total * 100;
        var loaded      = NumberFormat.formatBytes( event.loaded );
        var total       = NumberFormat.formatBytes( event.total );
        $( `#progress-resource-download--${data.module.instance} ons-progress-bar` )
            .attr( "value", percentagem )
            .find( "span" ).html( ` => ${loaded} de ${total}` );
    },

    make_offline__status : function( course, module ){

        return new Promise( function( resolve, reject ){

            var data = {
                courseids   : [ CourseUtil.course_selected.id ],
                wsfunction  : "mod_resource_get_resources_by_courses",
                offline_key : CourseUtil.course_selected.id
            };
            DataLoad.loadWebserviceOfflineData( data, function( data ){

                $.each( data.resources, function( id, resource ){

                    if( resource.id = module.instance ){
                        var fullurl;
                        var mimetype;
                        if( resource.contentfiles && resource.contentfiles[ 0 ] ){
                            if( resource.contentfiles[ 0 ].mimetype ){
                                mimetype = resource.contentfiles[ 0 ].mimetype;
                            }else{
                                reject();
                            }
                            if( resource.contentfiles[ 0 ].fileurl ){
                                fullurl = resource.contentfiles[ 0 ].fileurl;
                            }else{
                                reject();
                            }
                        }
                        else{
                            reject();
                        }

                        var fullurl_token = UrlUtil.addToken( fullurl );
                        var data          = { offline_key : CourseUtil.course_selected.id };
                        if( mimetype == "application/pdf" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
                        }
                        else if( mimetype == "audio/mp3" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
                        }
                        else if( mimetype == "video/mp4" ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
                        }
                        else if( mimetype.indexOf( "image/" ) === 0 ){
                            FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
                        }
                        else{
                            reject();
                        }
                    }else{
                        reject();
                    }
                } )

            }, null, true );
        } );
    },
};

CourseUtil.mods[ "resource" ] = ModResource;