ModScorm = {
    file_launch : null,

    cache : {},

    load_page : function(){
        PageOpen.pushPage( `page/mod/scorm/index.html`, CourseUtil.module_selected.name, ModScorm.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                scormid    : CourseUtil.module_selected.instance,
                wsfunction : "mod_scorm_view_scorm"
            }, false, true );
        }
    },

    show_module_load : function( status ){
        var promise = ModScorm.make_offline__status( CourseUtil.course_selected, CourseUtil.module_selected );
        promise.then(
            function( status ){
                ModScorm_offline.show_module_load_offline( ModScorm.file_launch );
            },
            function( reason ){
                if( status === false ) return;
                var promise = ModScorm.make_offline( CourseUtil.course_selected, CourseUtil.module_selected );
                promise.then(
                    function( value ){
                        ModScorm_offline.show_module_load_offline( ModScorm.file_launch );
                    },
                    function( reason ){
                        console.log( reason );
                    }
                );
            }
        );
    },

    make_offline : function( course, module ){
        return new Promise( function( resolve, reject ){
            // Carrega todos os SCORM's do curso
            var data = {
                courseids   : [ course.id ],
                wsfunction  : "mod_scorm_get_scorms_by_courses",
                offline_key : course.id
            };
            DataLoad.loadWebserviceOfflineData( data, function( data ){
                $.each( data.scorms, function( id, scorm ){
                    if( scorm.id = module.instance ){

                        var data = {
                            scormid     : module.instance,
                            wsfunction  : "mod_scorm_get_scorm_scoes",
                            offline_key : course.id
                        };
                        DataLoad.loadWebserviceOfflineData( data, function( data ){
                            console.log( data );

                            if( data.errorcode ){
                                reject( data );
                                return;
                            }

                            $.each( data.scoes, function( id, sco ){
                                if( scorm.launch == sco.id ){

                                    var file_launch = `${Offline.persistentPath}${course.id}-_-scorm-${module.instance}/${sco.launch}`;

                                    console.log( file_launch );
                                    resolveLocalFileSystemURL( file_launch,
                                        function( file ){
                                            console.log( [ "Arquivo existe", file ] );
                                            resolve( file_launch );
                                        },
                                        function( evt ){
                                            ModScorm.make_offline__baixar_scorm( course, module, scorm, function(){
                                                resolve( file_launch );
                                            }, reject );
                                        }
                                    );
                                }
                            } );
                        } );
                    }
                } );
            }, null, true );
        } );
    },

    make_offline__baixar_scorm : function( course, module, scorm, resolve, reject ){
        ModScorm_download.baixar( course, module, resolve, reject );
    },

    make_offline__baixar_scorm__progress : function( event, data ){

        if( !document.getElementById( `progress-instance-download--${data.module.instance}` ) ){
            var progress = `
                <ons-card id="progress-instance-download--${data.module.instance}" modifier="category">
                    <ons-progress-bar value="0">Download do SCORM<span>...</span></ons-progress-bar>
                </ons-card>`;
            $( "#page-mod-scorm-content" ).append( progress );
        }

        var percentagem = event.loaded / event.total * 100;
        $( `#progress-instance-download--${data.module.instance} ons-progress-bar` )
            .attr( "value", percentagem )
            .find( "span" ).html( ` => ${event.loaded} de ${event.total} partes` );

        $( `#progress-instance-zip--${data.module.instance}` ).remove();
    },

    make_offline__status : function( course, module ){
        return new Promise( function( resolve, reject ){

            var scormpath = `${Offline.persistentPath}${course.id}-_-scorm-${module.instance}/ok.txt`;
            try{
                console.log(scormpath);
                resolveLocalFileSystemURL( scormpath,
                    function( fileOk ){
                        resolve && resolve( fileOk );
                    },
                    function( error ){
                        reject && reject( error );
                    }
                );
            }catch( error ){
                console.log(error);
                reject && reject( error );
            }

        } );
    },
};


CourseUtil.mods[ "scorm" ] = ModScorm;