ModSupervideo = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/supervideo/index.html`, CourseUtil.module_selected.name, ModSupervideo.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id    : CourseUtil.module_selected.id,
                supervideoid : CourseUtil.module_selected.instance,
                wsfunction   : "mod_supervideo_view_supervideo"
            }, false, true );
        }
    },

    show_module_load : function(){

        ModSupervideo._internal_last_posicao_video = -1;
        ModSupervideo._internal_last_percent       = -1;
        ModSupervideo._internal_assistido          = [];
        ModSupervideo._internal_view_id            = 0;
        ModSupervideo._internal_progress_length    = 100;

        var module = CourseUtil.module_selected;

        $( "#page-mod-supervideo .toolbar__title" ).html( module.name );

        if( module.description ){
            $( "#page-mod-supervideo-content .description" ).html( module.description );
        }else if( module.intro ){
            $( "#page-mod-supervideo-content .intro" ).html( module.intro );
        }

        console.log( module.contents[ 0 ] );

        var config = JSON.parse( module.contents[ 0 ].license );
        if( config.showmapa ){
            $( "#mapa-visualizacao" ).show();
            $( "#mapa-visualizacao .mapa" ).attr( "data-mapa", config.datamapa );
        }
        ModSupervideo._internal_view_id = config.viewid;

        // link ou file
        if( module.contents[ 0 ].type == "link" || module.contents[ 0 ].type == "file" ){
            var fileurl = module.contents[ 0 ].fileurl;
            if( module.contents[ 0 ].type == "file" ){
                fileurl = UrlUtil.addToken( fileurl );
            }

            FileCache.saveAndGet( fileurl, { offline_key : CourseUtil.course_selected.id },
                function(){
                    var embed_code = "";
                    if( module.contents[ 0 ].filename.indexOf( ".mp3" ) > 0 ){
                        embed_code = $( `<audio id="supervideo-link" src="${fileurl}" width="100%" playsinline></audio>` );
                    }else{
                        embed_code = $( `<video id="supervideo-link" src="${fileurl}" width="100%" playsinline></video>` );
                    }

                    if( config.showcontrols ){
                        embed_code.attr( "controls", "controls" );
                    }
                    if( config.autoplay ){
                        embed_code.attr( "autoplay", "autoplay" );
                    }

                    $( "#page-mod-supervideo-content .data-content" ).html( embed_code );
                    var playerLink = window.plyr = new Plyr( `#supervideo-link` );

                    playerLink.on( "ready", function(){
                        if( config.currenttime ){
                            playerLink.currentTime = parseInt( config.currenttime );
                            setTimeout( function(){
                                playerLink.currentTime = parseInt( config.currenttime );
                            }, 1000 );

                            if( !config.autoplay ){
                                playerLink.pause();
                            }
                        }
                    } );
                    document.addEventListener( "setCurrentTime", function( event ){
                        playerLink.currentTime = event.detail.goCurrentTime;
                    } );
                    setInterval( function(){
                        ModSupervideo._internal_saveprogress( playerLink.currentTime, playerLink.duration );
                    }, 200 );
                }, function(){
                    $( "#supervideo-erro-carregar-arquivo .title" ).html( "Erro ao carregar o vídeo!" );
                    PageOpen.showDialog( "supervideo-erro-carregar-arquivo" );
                }, null, true );
        }

        // ottflix
        else if( module.contents[ 0 ].type == "ottflix" ){
        }

        // youtube
        else if( module.contents[ 0 ].type == "youtube" ){
            $( "#page-mod-supervideo-content .data-content" ).html( "<div id='youtube-supervideo-id'></div>" );

            var playerVars = {
                rel         : 0,
                controls    : config.showcontrols,
                autoplay    : config.autoplay,
                playsinline : 1,
            };
            if( config.currenttime ){
                playerVars.start = config.currenttime;
            }

            var youtubePartes = module.contents[ 0 ].fileurl.split( "watch?v=" );

            if( YT && YT.Player ){
                var playerYT = new YT.Player( "youtube-supervideo-id", {
                    suggestedQuality : 'large',
                    videoId          : youtubePartes[ 1 ],
                    width            : '100%',
                    playerVars       : playerVars,
                    events           : {
                        'onReady'       : function( event ){
                            if( config.playersize == 1 ){
                                ModSupervideo._internal_resize( 16, 9 );
                            }else if( config.playersize == 2 ){
                                ModSupervideo._internal_resize( 4, 3 );
                            }else if( config.playersize.indexOf( "x" ) ){
                                var sizes = config.playersize.split( "x" );
                                ModSupervideo._internal_resize( sizes[ 0 ], sizes[ 1 ] );
                            }

                            document.addEventListener( "setCurrentTime", function( event ){
                                playerYT.seekTo( event.detail.goCurrentTime );
                            } );

                            setInterval( function(){
                                if( playerYT && playerYT.getCurrentTime != undefined ){
                                    ModSupervideo._internal_saveprogress( playerYT.getCurrentTime(), playerYT.getDuration() - 1 );
                                }
                            }, 150 );
                        },
                        'onStateChange' : function( event ){
                        }
                    }
                } );
            }else{
                var html =
                        '<div class="alert alert-danger">' +
                        '    Error loading the JavaScript at https://www.youtube.com/iframe_api. ' +
                        '    Please check for any Security Policy restrictions.' +
                        '</div>';
                $( "#youtube-supervideo-id" ).html( html );

                $( "#supervideo-erro-carregar-arquivo .title" ).html( "Erro ao carregar o vídeo do Youtube!" );
                PageOpen.showDialog( "supervideo-erro-carregar-arquivo" );
            }

            setInterval( function(){
                if( playerYT && playerYT.getCurrentTime != undefined ){
                    ModSupervideo._internal_saveprogress( playerYT.getCurrentTime(), playerYT.getDuration() - 1 );
                }
            }, 150 );
        }

        // google-drive
        else if( module.contents[ 0 ].type == "google-drive" ){
            var htmlDrive = `<iframe id="drive-iframe" width="100%" height="100%" style="min-height:480px"
                                     frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen
                                     allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                                     sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                                     src="${module.contents[ 0 ].fileurl}"></iframe>`;
            $( "#page-mod-supervideo-content .data-content" ).html( htmlDrive );
            $( "#mapa-visualizacao" ).hide();
            ModSupervideo._internal_resize( width, height );

            if( config.playersize == 5 ){
                ModSupervideo._internal_resize( 480, 640 );
            }else if( config.playersize == 6 ){
                ModSupervideo._internal_resize( 4, 3 );
            }else if( config.playersize == 7 ){
                ModSupervideo._internal_resize( 16, 9 );
            }else if( config.playersize.indexOf( "x" ) ){
                var sizes = config.playersize.split( "x" );
                ModSupervideo._internal_resize( sizes[ 0 ], sizes[ 1 ] );
            }
        }

        // Vimeo
        else if( module.contents[ 0 ].type == "vimeo" ){
            var htmlVimeo = `<iframe id="vimeo-iframe" width="100%" height="100%"
                                     frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen
                                     allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                                     sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                                     src="${module.contents[ 0 ].fileurl}"></iframe>`;
            $( "#page-mod-supervideo-content .data-content" ).html( htmlVimeo );

            var playerVimeo = new Vimeo.Player( document.getElementById( "vimeo-iframe" ) );

            if( config.currenttime ){
                playerVimeo.setCurrentTime( config.currenttime );
            }

            document.addEventListener( "setCurrentTime", function( event ){
                playerVimeo.setCurrentTime( event.detail.goCurrentTime );
            } );

            Promise.all( [ playerVimeo.getVideoWidth(), playerVimeo.getVideoHeight() ] ).then( function( dimensions ){
                var width  = dimensions[ 0 ];
                var height = dimensions[ 1 ];

                ModSupervideo._internal_resize( width, height );
            } );

            var duration = 0;
            setInterval( function(){
                if( duration > 1 ){
                    playerVimeo.getCurrentTime().then( function( _currenttime ){
                        _currenttime = parseInt( _currenttime );
                        ModSupervideo._internal_saveprogress( _currenttime, duration );
                    } );
                }else{
                    playerVimeo.getDuration().then( function( _duration ){
                        duration = _duration;
                    } );
                }
            }, 300 );
        }
    },

    _internal_resize             : function( width, height ){

        function _resizePage(){
            var videoBoxWidth  = $( "#page-mod-supervideo-content" ).width();
            var videoBoxHeight = videoBoxWidth * height / width;

            $( "#page-mod-supervideo-content iframe" ).css( {
                //width  : videoBoxWidth,
                height : videoBoxHeight,
            } );
        }

        $( window ).resize( _resizePage );
        _resizePage();


        var element   = $( "#page-mod-supervideo-content" );
        var lastWidth = element.width();
        setInterval( function(){
            if( lastWidth === element.width() ) return;
            lastWidth = element.width();

            _resizePage();
        }, 500 );

        return element;

    },
    _internal_last_posicao_video : -1,
    _internal_last_percent       : -1,
    _internal_assistido          : [],
    _internal_view_id            : 0,
    _internal_progress_length    : 100,
    _internal_saveprogress       : function( currenttime, duration ){

        currenttime = Math.floor( currenttime );
        duration    = Math.floor( duration );

        if( !duration ){
            return 0;
        }

        if( duration && ModSupervideo._internal_assistido.length == 0 ){
            ModSupervideo._internal_progress_create( duration );
        }

        if( ModSupervideo._internal_progress_length < 100 ){
            posicao_video = currenttime;
        }else{
            var posicao_video = parseInt( currenttime / duration * ModSupervideo._internal_progress_length );
        }

        if( ModSupervideo._internal_last_posicao_video == posicao_video ) return;
        ModSupervideo._internal_last_posicao_video = posicao_video;

        if( posicao_video ){
            ModSupervideo._internal_assistido[ posicao_video ] = 1;
        }

        var percent = 0;
        for( var j = 1; j <= ModSupervideo._internal_progress_length; j++ ){
            if( ModSupervideo._internal_assistido[ j ] ){
                percent++;
                $( "#mapa-visualizacao-" + j ).css( { opacity : 1 } );
            }
        }

        if( ModSupervideo._internal_progress_length < 100 ){
            percent = Math.floor( percent / ModSupervideo._internal_progress_length * 100 );
        }

        if( ModSupervideo._internal_last_percent == percent )
            return;
        ModSupervideo._internal_last_percent = percent;

        if( currenttime ){
            var data = {
                wsfunction  : "mod_supervideo_progress_save_mobile",
                view_id     : ModSupervideo._internal_view_id,
                currenttime : parseInt( currenttime ),
                duration    : parseInt( duration ),
                percent     : parseInt( percent ),
                mapa        : JSON.stringify( ModSupervideo._internal_assistido ),
            };
            DataLoad.loadWebserviceOfflineData( data );
        }

        if( percent >= 0 ){
            $( "#seu-mapa-view span" ).html( percent + "%" );
        }
    },

    _internal_progress_create : function( duration ){

        var $mapa = $( "#mapa-visualizacao .mapa" );
        if( !$mapa.length ){
            return;
        }

        var supervideo_view_mapa = [];
        try{
            var mapa_json_base64 = $mapa.attr( 'data-mapa' );
            if( mapa_json_base64 ){
                supervideo_view_mapa = JSON.parse( atob( mapa_json_base64 ) );
            }
        }catch( e ){
            supervideo_view_mapa = [];
        }

        if( Math.floor( duration ) <= 100 ){
            ModSupervideo._internal_progress_length = Math.floor( duration );
        }
        for( var i = 1; i <= ModSupervideo._internal_progress_length; i++ ){
            if( typeof supervideo_view_mapa[ i ] != "undefined" ){
                ModSupervideo._internal_assistido[ i ] = supervideo_view_mapa[ i ];
            }else{
                ModSupervideo._internal_assistido[ i ] = 0;
            }
            var $mapa_item = $( "<div id='mapa-visualizacao-" + i + "'>" );
            $mapa.append( $mapa_item );

            // Mapa Clique
            var mapaTitle = Math.floor( duration / ModSupervideo._internal_progress_length * i );

            var hours   = Math.floor( mapaTitle / 3600 );
            var minutes = (Math.floor( mapaTitle / 60 )) % 60;
            var seconds = mapaTitle % 60;

            var tempo = minutes + ":" + seconds;
            if( hours ){
                tempo = hours + ":" + minutes + ":" + seconds;
            }
            var $mapa_clique =
                    $( "<div id='mapa-visualizacao-" + i + "'>" )
                        .attr( "title", 'Ir para ' + tempo )
                        .attr( "data-currenttime", mapaTitle )
                        .click( function(){
                            var _setCurrentTime = $( this ).attr( "data-currenttime" );
                            _setCurrentTime     = parseInt( _setCurrentTime );

                            var event = document.createEvent( 'CustomEvent' );
                            event.initCustomEvent( 'setCurrentTime', true, true, { goCurrentTime : _setCurrentTime } );
                            document.dispatchEvent( event );
                        } );
            $( "#mapa-visualizacao .clique" ).append( $mapa_clique );
        }
    },

    make_offline : function( course, module ){
        return new Promise( function( resolve, reject ){

            // link ou file
            if( module.contents[ 0 ].type == "link" || module.contents[ 0 ].type == "file" ){

                var fileurl = module.contents[ 0 ].fileurl;
                if( module.contents[ 0 ].type == "file" ){
                    fileurl = UrlUtil.addToken( fileurl );
                }

                var data = { offline_key : CourseUtil.course_selected.id };
                FileCache.saveAndGet( fileurl, data, resolve, reject );
            }

            // ottflix
            else if( module.contents[ 0 ].type == "ottflix" ){
            }
        } )
    },

    make_offline__status : function( course, module ){
        return new Promise( function( resolve, reject ){

            // link ou file
            if( module.contents[ 0 ].type == "link" || module.contents[ 0 ].type == "file" ){

                var fileurl = module.contents[ 0 ].fileurl;
                if( module.contents[ 0 ].type == "file" ){
                    fileurl = UrlUtil.addToken( fileurl );
                }

                var data = { offline_key : CourseUtil.course_selected.id };
                FileCache.saveAndGet( fileurl, data, resolve, reject, null, true );
            }

            // ottflix
            else if( module.contents[ 0 ].type == "ottflix" ){
                resolve();
            }

            // Qualquer outro.
            else{
                reject();
            }
        } )
    },
};

CourseUtil.mods[ "supervideo" ] = ModSupervideo;