ModUrl = {
    load_page : function(){
        PageOpen.pushPage( `page/mod/url/index.html`, CourseUtil.module_selected.name, ModUrl.show_module_load );

        if( CourseUtil.module_selected.completion == 1 && !CourseUtil.module_selected.completiondata.state ){
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                cmid       : CourseUtil.module_selected.id,
                completed  : 1,
                wsfunction : "core_completion_update_activity_completion_status_manually",
            }, false, true );
        }else{
            ModMakeView.call( {
                module_id  : CourseUtil.module_selected.id,
                urlid      : CourseUtil.module_selected.instance,
                wsfunction : "mod_url_view_url"
            }, false, true );
        }
    },

    show_module_load : function(){

        var module = CourseUtil.module_selected;

        $( "#page-mod-url .toolbar__title" ).html( module.name );

        var $module = $( "<ons-card></ons-card>" );
        if( module.description ){
            $module.append( `<div>${module.description}</div>` );
        }else if( module.intro ){
            $module.append( `<div>${module.intro}</div>` );
        }

        $module.append( `<div class="data-content"></div>` );
        $( "#page-mod-url-content" ).html( $module );

        var fullurl = "";
        if( module.contents && module.contents[ 0 ] && module.contents[ 0 ].fileurl ){
            fullurl = module.contents[ 0 ].fileurl;
        }else{
            var customdata = JSON.parse( module.customdata );
            if( customdata && customdata.fullurl ){
                fullurl = customdata.fullurl;
            }
        }

        var data;

        // PDF
        if( ModUrl.testUrlPdfFile( fullurl ) ){

            var fullurl_token = UrlUtil.addToken( fullurl );
            var dataOffline   = {
                offline_key : CourseUtil.course_selected.id,
                module      : module,
            };
            FileCache.saveAndGet( fullurl_token, dataOffline,
                function( localUrl ){
                    // <iframe id="module-embed-${module.id}" src="${fullurl_token}"
                    $( "#page-mod-url .content" ).html(
                        `<iframe id="module-embed-${module.id}" src="players/pdf/web/viewer.html?file=${fullurl_token}"
                                 allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                                 sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                                 style="height: 100%;width: 100%;" allowfullscreen frameborder="0"></iframe>` );
                },
                function(){
                    PageOpen.showDialog( "url-erro-carregar-arquivo" );
                    $( "#url-erro-carregar-arquivo .title" ).html( "Erro ao carregar o PDF!" );
                }, ModUrl.make_offline__baixar_url__progress );
        }

        // Youtube
        else if( data = ModUrl.testUrlYouTube( fullurl ) ){
            $( "#page-mod-url .data-content" ).html(
                `<div class="plyr__video-embed" id="module-embed-${module.id}">
                     <iframe src="https://www.youtube.com/embed/${data}"
                             allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                             sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                             width="100%" height="315" allowfullscreen frameborder="0"></iframe>
                 </div>` );

            window.plyr = new Plyr( `#module-embed-${module.id}` );
        }

        // Vimeo
        else if( data = ModUrl.testUrlVimeo( fullurl ) ){
            $( "#page-mod-url .data-content" ).html(
                `<div class="plyr__video-embed" id="module-embed-${module.id}">
                     <iframe src="https://player.vimeo.com/video/${data}"
                             allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                             sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                             width="100%" height="315" allowfullscreen frameborder="0"></iframe>
                 </div>` );

            window.plyr = new Plyr( `#module-embed-${module.id}` );
        }

        // Google Drive
        else if( data = ModUrl.testUrlDrive( fullurl ) ){
            // console.log ( data );

            $( "#page-mod-url .data-content" ).html(
                `<iframe src="https://drive.google.com/file/d/${data}/preview"
                         allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                         sandbox="allow-scripts allow-forms allow-same-origin allow-modals allow-presentation"
                         width="100%" height="500" allowfullscreen frameborder="0"></iframe>` );

        }

        // Video
        else if( data = ModUrl.testUrlVideo( fullurl ) ){
            // console.log ( data );

            var embed_code = "";
            if( data == "mp4" ){
                embed_code = `<video src="${fullurl}" width="100%" height="315" controls playsinline></video>`;
            }else{
                embed_code = `<audio src="${fullurl}" width="100%" height="315" controls></audio>`;
            }

            $( "#page-mod-url .data-content" ).html( embed_code );
            window.plyr = new Plyr( `#module-embed-${module.id}` );

        }

        // Outros
        else{
            var html = `<p><strong>URL direciona para</strong><br>${fullurl}</p>
                        <ons-button id="open-url-external" modifier="large" class="button-margin">Abrir conteúdo</ons-button>`;
            $( "#page-mod-url .data-content" ).html( html );
            $( "#open-url-external" ).click( function(){
                OpenUrl.open_external_logged( fullurl );
            } );
        }
    },

    testUrlYouTube : function( url ){
        var re      = /\/\/(?:www\.)?youtu(?:\.be|be\.com)\/(?:watch\?v=|embed\/)?([a-z0-9_\-]+)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlVimeo   : function( url ){
        var re      = /\/\/(?:www\.)?vimeo.com\/([0-9a-z\-_]+)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlDrive   : function( url ){
        var re      = /https:\/\/(docs.google.com|drive.google.com)\//i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlVideo   : function( url ){
        var re      = /^https?.*\.(mp3|mp4|webm|aac)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },
    testUrlPdfFile : function( url ){
        var re      = /^https?.*\.(pdf)/i;
        var matches = re.exec( url );
        return matches && matches[ 1 ];
    },

    make_offline : function( course, module ){
        return new Promise( function( resolve, reject ){
            var fullurl = module.contents[ 0 ].fileurl;

            var fullurl_token = UrlUtil.addToken( fullurl );
            var data          = { offline_key : CourseUtil.course_selected.id };
            if( ModUrl.testUrlVideo( fullurl ) ){
                FileCache.saveAndGet( fullurl_token, data, resolve, reject );
            }
            else if( ModUrl.testUrlPdfFile( fullurl ) ){
                FileCache.saveAndGet( fullurl_token, data, resolve, reject );
            }
            else{
                resolve();
            }
        } );
    },

    make_offline__baixar_url__progress : function( event, data ){
        if( !document.getElementById( `progress-url-download--${data.module.instance}` ) ){
            var progress = `
                <ons-card id="progress-url-download--${data.module.instance}" modifier="category">
                    <ons-progress-bar value="0">Download do PDF<span>...</span></ons-progress-bar>
                </ons-card>`;
            $( "#page-mod-url .content" ).append( progress );
        }

        var percentagem = event.loaded / event.total * 100;
        var loaded      = NumberFormat.formatBytes( event.loaded );
        var total       = NumberFormat.formatBytes( event.total );
        $( `#progress-url-download--${data.module.instance} ons-progress-bar` )
            .attr( "value", percentagem )
            .find( "span" ).html( ` => ${loaded} de ${total}` );
    },

    make_offline__status : function( course, module ){
        return new Promise( function( resolve, reject ){
            var fullurl = module.contents[ 0 ].fileurl;

            var fullurl_token = UrlUtil.addToken( fullurl );
            var data          = { offline_key : CourseUtil.course_selected.id };
            if( ModUrl.testUrlVideo( fullurl ) ){
                FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
            }
            else if( ModUrl.testUrlPdfFile( fullurl ) ){
                FileCache.saveAndGet( fullurl_token, data, resolve, reject, null, true );
            }
            else{
                reject();
            }
        } );
    },
};

CourseUtil.mods[ "url" ] = ModUrl;