DownloadCourse = {

    status : {},

    setDownloadStatus : function( course_id, status, progress ){
        var $statusDownload = $( `#status-download-${course_id}` );
        $statusDownload.attr( 'class', `status-download ${status}` );

        if( progress ){
            $statusDownload.find( ".course-progress" ).attr( "value", progress );
        }
    },

    apagarCurso : function(){
        ons.openActionSheet( {
            title      : '',
            cancelable : true,
            buttons    : [
                { label : 'Apagar dados offline', modifier : 'destructive' },
                { label : 'Cancelar', icon : 'md-close' }
            ]
        } ).then( function( index ){
            // console.log ( 'index: ', index );

            if( index == 0 ){
                onApagarDadosOffline();
            }else if( index == 1 ){
                // Apenas sai sem precisar fazer nada
            }
        } );

        function onApagarDadosOffline(){
            var key = `course-offline-${CourseUtil.course_selected.id}`;
            Offline.deleteOffline( key );

            FileCache.deleteByCourse( CourseUtil.course_selected.id );
            DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-baixar" );

            console.trace( 'Dados offline apagados com sucesso!' );
            ons.notification.toast( 'Dados offline apagados com sucesso!', {
                buttonLabel : 'OK',
                timeout     : 1500
            } );

            DownloadCourse.sendEventReload( CourseUtil.course_selected.id );
        }
    },

    download : function(){
        DownloadCourse.status[ CourseUtil.course_selected.id ] = "progress";
        DownloadCourse.setDownloadStatus( CourseUtil.course_selected.id, "course-progress" );

        $.each( FormatTopics.core_course_get_contents, DownloadCourse.downloadSection );
    },

    modulos         : {},
    downloadSection : function( key, section ){
        // console.log ( [ "Section", section ] );

        if( !section.visible ) return;
        if( !section.uservisible ) return;

        var course = CourseUtil.course_selected;

        if( !DownloadCourse.modulos[ course.id ] ){
            DownloadCourse.modulos[ course.id ] = {};
        }

        // console.log ( [ "Carregar Section", section ] );
        $.each( section.modules, function( id, module ){

            // console.log ( [ "Modulo", module.name ] );

            if( !module.visible ) return;

            if( CourseUtil.mods[ module.modname ] ){
                var ModClass = CourseUtil.mods[ module.modname ];

                if( !ModClass.make_offline_disables ){
                    DownloadCourse.modulos[ course.id ][ module.id ] = 0;

                    // console.log ( [ "Baixar modulo", module.name ] );
                    var promise = ModClass.make_offline( course, module );
                    promise.then(
                        function( value ){
                            // sucesso no download
                            // console.log ( value );
                            DownloadCourse.modulos[ course.id ][ module.id ] = 1;

                            DownloadCourse.downloadModules_successs( course, DownloadCourse.modulos[ course.id ] );
                        },
                        function( reason ){
                            // erro no download
                            // console.error ( reason );
                            DownloadCourse.modulos[ course.id ][ module.id ] = 2;

                            DownloadCourse.downloadModules_successs( course, DownloadCourse.modulos[ course.id ] );
                        }
                    );
                }
            }else{
                // aqui módulos acessados na WEB
            }
        } );
    },

    downloadModules_successs : function( course, modulos ){
        window.modulos = modulos;
        // console.log ( modulos );

        var totalModulos     = 0;
        var completosModulos = 0;
        var iterate          = $.each( window.modulos, function( id, status ){
            totalModulos++;
            if( status ){
                completosModulos++;
            }
        } );
        $.when( iterate ).done( function(){

            if( completosModulos == totalModulos ){
                DownloadCourse.setDownloadStatus( course.id, "course-done" );

                var key = `course-offline-${course.id}`;
                Offline.insertOffline( key, "done" );

                delete DownloadCourse.status[ course.id ];

                DownloadCourse.sendEventReload( course.id );

            }else{
                var percent = completosModulos * 100 / totalModulos;
                // console.log ( percent + "%" );

                DownloadCourse.setDownloadStatus( course.id, "course-progress", percent );
            }
        } );
    },

    sendEventReload : function( courseid ){
        var event = new CustomEvent( "course_reloaded", { courseid : courseid } );
        document.dispatchEvent( event );
    }
};