ModMakeView = {
    call : function( postData, offlineKey, dispachEvent ){
        postData.wstoken            = Login.token;
        postData.moodlewsrestformat = "json";

        var postData_module_id = postData.module_id;
        delete postData.module_id;

        var url = `${AppConfig.wwwroot}/webservice/rest/server.php?wsfunction=${postData.wsfunction}`;
        DataLoad.load( url, postData,
            successCallback = function(){
                if( offlineKey ){
                    ModMakeView.__deleteMakeView( offlineKey );
                }
                if( dispachEvent === true ){
                    if( $( `#module-${postData_module_id} .completion-info-n` ).length ){
                        var event = new CustomEvent( "modmakeview_loaded", {} );
                        document.dispatchEvent( event );
                    }
                }
            },
            errorCallback = function(){
                if( offlineKey ) return;

                ModMakeView.__insertMakeView( postData );
            }, false );
    },

    init_cron : function(){
        setInterval( function(){
            var txn         = Offline.db.transaction( 'makeview', "readonly" );
            var objectStore = txn.objectStore( 'makeview' );

            objectStore.openCursor().onsuccess = function( event ){
                var data = event.target.result;
                if( data ){
                    //console.log ( data );
                    ModMakeView.__cronMakeView( data );

                    data.continue();
                }
            };
        }, 5 * 60 * 1000 ); // a cada 5 minutos
    },

    __cronMakeView : function( data ){
        var makeView = data.value;
        var key      = data.key;

        makeView.module_id = CourseUtil.module_selected.id;

        ModMakeView.call( makeView, key, false );
    },

    __insertMakeView : function( makeView ){
        // create a new transaction
        var txn = Offline.db.transaction( 'MakeView', 'readwrite' );

        // get the MakeView object store
        var store = txn.objectStore( 'MakeView' );
        var query = store.put( makeView );

        // handle success case
        query.onsuccess = function( event ){
            // console.log ( event );
        };

        // handle the error case
        query.onerror = function( event ){
            // console.error ( event.target.errorCode );
        };
    },
    __deleteMakeView : function( key ){
        // create a new transaction
        var txn = Offline.db.transaction( 'makeview', 'readwrite' );

        // get the MakeView object store
        var store = txn.objectStore( 'makeview' );
        var query = store.delete( key );

        // handle the success case
        query.onsuccess = function( event ){
            //console.log ( event );
        };

        // handle the error case
        query.onerror = function( event ){
            //console.error ( event.target.errorCode );
        };
    }
};